﻿local AddOn, C = ...
local L = AleaUI_GUI.GetLocale("FeralDotDamage")

local rakeDamage = 0.47
local is60200 = false
local rakeDamagePog = 0.2
local shadowmeldDebug = false
local build = select(2, GetBuildInfo())
local versionStr, internalVersion, dateofpatch, uiVersion = GetBuildInfo()
internalVersion = tonumber(internalVersion)

local incarnationFix = false

if uiVersion >= 70000 then
	rakeDamage = 0.80
elseif internalVersion >= 20444 then
	rakeDamage = 0.62
	is60200 = true
elseif uiVersion >= 60200 then
	rakeDamage = 0.517
	is60200 = true
end


C = CreateFrame("Frame")
C:SetScript("OnEvent", function(self, event, ...)
	self[event](self, event, ...)
end)

_G[AddOn] = C

C.SharedMedia = LibStub("LibSharedMedia-3.0")
C.SharedMedia:Register("border", "WHITE8x8", [[Interface\Buttons\WHITE8x8]])
C.SharedMedia:Register("statusbar", "WHITE8x8", [[Interface\Buttons\WHITE8x8]])


local RegisterSound = function(path, name)
	C.SharedMedia:Register("sound", name, path)
end

RegisterSound("Sound\\Spells\\SoulstoneResurrection_Base.ogg","Soulstone");
RegisterSound("Sound\\Spells\\EnlargeCast.ogg","Enlarge");
RegisterSound("Sound\\Spells\\FluteRun.ogg","Flute");
RegisterSound("Sound\\Spells\\ShadowWard.ogg","Shadow Ward");
RegisterSound("Sound\\Spells\\ShadowWordSilence.ogg","Silence");
RegisterSound("Sound\\Spells\\ShadowWordPain_Chest.ogg","Shadow Word Pain");
RegisterSound("Sound\\Spells\\ShadowWordFumble.ogg","Fumble");
RegisterSound("Sound\\Spells\\AntiHoly.ogg","Anti Holy");
RegisterSound("Sound\\Spells\\Bonk1.ogg","Bonk1");
RegisterSound("Sound\\Spells\\Bonk2.ogg","Bonk2");
RegisterSound("Sound\\Spells\\Bonk3.ogg","Bonk3");
RegisterSound("Sound\\Spells\\consume_magic_impact.ogg","Consume Magic");
RegisterSound("Sound\\Spells\\Creature_SpellPortalLarge_All_Colors.ogg","Spell Portal");
RegisterSound("Sound\\Spells\\Ingvar_ResurrectionGroundVisual.ogg","Resurrection Ground");
RegisterSound("Sound\\Spells\\Resurrection.ogg","Resurrection");
RegisterSound("Sound\\Spells\\Rogue_shadowdance_state.ogg","Shadow Dance");
RegisterSound("Sound\\Spells\\ShaysBell.ogg","Shay's Bell");
RegisterSound("Sound\\Spells\\SimonGame_Visual_BadPress.ogg","Simon Error");
RegisterSound("Sound\\Spells\\SimonGame_Visual_GameFailedLarge.ogg","Simon Failed Large");
RegisterSound("Sound\\Spells\\SimonGame_Visual_GameFailedSmall.ogg","Simon Failed Small");
RegisterSound("Sound\\Spells\\SimonGame_Visual_GameStart.ogg","Simon Start");
RegisterSound("Sound\\Spells\\SimonGame_Visual_GameTick.ogg","Simon Tick");
RegisterSound("Sound\\Spells\\SimonGame_Visual_LevelStart.ogg","Simon Level Start");

local imprived_rake_gained = false
local moonfire_talent = false
local show_moonfire_icon = false

local savage_roar_talent = false
local show_savage_roar_icon = false

local CLEAR_CAST_FIND = false
local trottle1 = 0.1

local SR_COMBO_POINTS = 0

C.disable_addon = false
C.partial_disable_addon = false
C.only_in_cantForm = false

local debugging = false

local hookrake = false
--155625

C.tigrinoe_spid = 5217
C.tigrinoe_name = GetSpellInfo(C.tigrinoe_spid)
local tigrinoe_spid = C.tigrinoe_spid
local tigrinoe_name = C.tigrinoe_name


C.dikiyrev_spid = 52610
C.dikiyrev_name = GetSpellInfo(C.dikiyrev_spid)
local dikiyrev_spid = C.dikiyrev_spid
local dikiyrev_name = C.dikiyrev_name


C.dikiyrev_glyph_spid = 174544
C.dikiyrev_glyph_name = GetSpellInfo(C.dikiyrev_glyph_spid)
local dikiyrev_glyph_spid = C.dikiyrev_glyph_spid
local dikiyrev_glyph_name = C.dikiyrev_glyph_name

C.krovaviekogti_spid = 145152
C.krovaviekogti_name = GetSpellInfo(C.krovaviekogti_spid)
local krovaviekogti_spid = C.krovaviekogti_spid 
local krovaviekogti_name = C.krovaviekogti_name

C.pererogdenie_spid = 102543
C.pererogdenie_name = GetSpellInfo(C.pererogdenie_spid)
local pererogdenie_spid = C.pererogdenie_spid
local pererogdenie_name = C.pererogdenie_name

C.glybokayrana_spid = 155722
C.glybokayrana_name = GetSpellInfo(C.glybokayrana_spid)
local glybokayrana_spid = C.glybokayrana_spid
local glybokayrana_name = C.glybokayrana_name

C.razorvat_spid = 1079 
local razorvat_spid = C.razorvat_spid
local razorvat_name, _, razorvat_texture  = GetSpellInfo(C.razorvat_spid)
C.razorvat_name, C.razorvat_texture = razorvat_name, razorvat_texture

C.vzbuchka_spid = 106830
C.vzbuchka_name = GetSpellInfo(C.vzbuchka_spid)
local vzbuchka_spid = C.vzbuchka_spid
local vzbuchka_name = C.vzbuchka_name

C.catform_spid = 768
C.catform_name = GetSpellInfo(C.catform_spid)
local catform_spid = C.catform_spid
local catform_name = C.catform_name

C.cathumanform_spid = 171745
C.cathumanform_name = GetSpellInfo(C.cathumanform_spid)
local cathumanform_spid = C.cathumanform_spid
local cathumanform_name = C.cathumanform_name

C.bearform_spid = 5487
C.bearform_name = GetSpellInfo(C.bearform_spid)
local bearform_spid = C.bearform_spid
local bearform_name = C.bearform_name

C.moonfire_spid = 155625 -- 155625 for Cat, 164812 for Human
C.moonfire_name = GetSpellInfo(C.moonfire_spid)
local moonfire_spid = C.moonfire_spid
local moonfire_name = C.moonfire_name

C.stealth_spid = 5215
C.stealth_name = GetSpellInfo(C.stealth_spid)
local stealth_spid = C.stealth_spid
local stealth_name = C.stealth_name

C.incarnation_spid = 102543
C.incarnation_name = GetSpellInfo(C.incarnation_spid)
local incarnation_spid = C.incarnation_spid
local incarnation_name = C.incarnation_name

C.fb_id = 22568
local fb_id = C.fb_id
local fb_name, _, fb_texture = GetSpellInfo(C.fb_id)
C.fb_name, C.fb_texture = fb_name, fb_texture

C.clearcast_id = 135700
C.clearcast_name = GetSpellInfo(C.clearcast_id)
local clearcast_id = C.clearcast_id
local clearcast_name = C.clearcast_name


local OnUpdateFrames = CreateFrame("Frame")
OnUpdateFrames:SetScript("OnUpdate", function(self, elapsed)
	
	self.elapsed = ( self.elapsed or 0 ) + elapsed
	if self.elapsed < 0.05 then return end
	C:UpdateVisible()
end)

local GLOBAL_SCALE = 1
local GLOBAL_FONT_SIZE = 24

local dot_store = {}

local hideauraTime = 0
local hideauraTime2 = 0
local hideauraTime3 = 0
local detectrakeBonus = false

C.dot_store = dot_store

local dots_info = {
	
	[glybokayrana_spid] 	= { 3, 15, 19.5 , 	glybokayrana_name,	4.5}, -- tick period, default duration, pandemia duration
	[razorvat_spid] 		= { 2, 24, 31.2 , 	razorvat_name,		7.2},
	[vzbuchka_spid] 		= { 3, 15, 19.5 , 	vzbuchka_name,		4.5},
	[dikiyrev_spid] 		= { 0, 0, 0 ,	 	dikiyrev_name,		12.6},
	[dikiyrev_glyph_spid] 	= { 0, 0, 0 , 		dikiyrev_name,		12.6},
	[moonfire_spid] 		= { 2, 14, 18.2 , 	moonfire_name, 		4.2},
	[339]					= { 0, 30, 30,		( GetSpellInfo(339) ), 0 },
	[102359]				= { 0, 20, 20, 		( GetSpellInfo(102359) ), 0 },
}

local function GetAuras()
	local tigrinie_neistvo = UnitAura("player", tigrinoe_name) 	 -- 15%
	local dikiy_rev		   = UnitAura("player", dikiyrev_name) 	 -- 40%
	local krovavie_kogti   = UnitAura("player", krovaviekogti_name) or ( hideauraTime2 > GetTime() ) -- 30%
	local imprake		   = 
								UnitAura("player", stealth_name) or 
								( not incarnationFix and UnitAura("player", incarnation_name) ) or 
								UnitAura("player", ( GetSpellInfo(58984) )) or 
								( detectrakeBonus and hideauraTime3 > GetTime() ) or 
								( hideauraTime > GetTime() )-- 100%

	return tigrinie_neistvo, dikiy_rev, krovavie_kogti, imprake
end


function C:UpdateDamageMods(guid, spellid, dstName)
	local tigrinie_neistvo, dikiy_rev, krovavie_kogti, imp_rake = GetAuras()
	
	self:RegisterDot(guid, spellid)
	
	if spellid ~=  moonfire_spid then
	
		dot_store[guid..spellid][9]  = tigrinie_neistvo and true or false
		dot_store[guid..spellid][10] = dikiy_rev and true or false
		dot_store[guid..spellid][11] = krovavie_kogti and true or false
		
		if spellid == glybokayrana_spid and imprived_rake_gained then
			dot_store[guid..spellid][12] = imp_rake and true or false
		else
			dot_store[guid..spellid][12] = false
		end
	
	end
	dot_store[guid..spellid][18] = dstName
	
	
--	print("T", "UpdateDamageMods", guid, spellid, dstName)
end

function C:SyncTickTimer(guid, spellid)
	
--	dot_store[guid..spellid]
	
end


function C:GetDebugColor(guid, spellid)

	local tigrinie_neistvo = dot_store[guid..spellid] and dot_store[guid..spellid][9] or false
	local dikiy_rev = dot_store[guid..spellid] and dot_store[guid..spellid][10] or false
	local krovavie_kogti = dot_store[guid..spellid] and dot_store[guid..spellid][11] or false
	local impr_rake = dot_store[guid..spellid] and dot_store[guid..spellid][12] or false
	
	return tigrinie_neistvo, dikiy_rev, krovavie_kogti, impr_rake
end

--local form_real = 0
local function GetForm(update) -- 0 - human ; 1 - bear; 2 - cat
	--[==[
	if update then
	
		local catform = UnitAura("player", catform_name, nil, "PLAYER")	or UnitAura("player", cathumanform_name, nil, "PLAYER")
		if catform then 
			form_real = 2 
			return form_real
		end

		local bearform = UnitAura("player", bearform_name, nil, "PLAYER")		
		if bearform then 
			form_real = 1 
			return form_real
		end

		form_real = 0
	end

	return form_real
	]==]
	local form = GetShapeshiftFormID()
	if form == CAT_FORM or form == BEAR_FORM then
		return form
	end
	
	return 0
end

function C:GetDotBuffValue(guid, spellid)

	if spellid == moonfire_spid then
		return 1, 1	
	end
	
	local cur_tigrinie_neistvo, cur_dikiy_rev, cur_krovavie_kogti, cur_imp_rake = GetAuras()

	local tigrinie_neistvo = dot_store[guid..spellid] and dot_store[guid..spellid][9] or false
	local dikiy_rev = dot_store[guid..spellid] and dot_store[guid..spellid][10] or false
	local krovavie_kogti = dot_store[guid..spellid] and dot_store[guid..spellid][11] or false
	local impr_rake = dot_store[guid..spellid] and dot_store[guid..spellid][12] or false
	
	local total_cur = 1
	local total = 1
	
	if cur_tigrinie_neistvo then total_cur = total_cur * 1.15 end
	if cur_dikiy_rev then total_cur = total_cur * 1.25 end -- 1.4 for WoD
	if cur_krovavie_kogti then total_cur = total_cur * 1.4 end
	if imprived_rake_gained and cur_imp_rake and spellid == glybokayrana_spid then total_cur = total_cur * 2 end
	
	if tigrinie_neistvo then total = total * 1.15 end
	if dikiy_rev then total = total * 1.25 end -- 1.4 for WoD
	if krovavie_kogti then total = total * 1.4 end
	if imprived_rake_gained and impr_rake and spellid == glybokayrana_spid then total = total * 2 end
	
	if C.db.profile.count_cp_to_power and spellid == razorvat_spid then		
		total_cur = total_cur*0.2*UnitPower("player", 4)
		total = total*0.2*dot_store[guid..spellid][17]
	end
	
	return total_cur, total 
end

local function OnUpdate(self, elapsed)
	self.elapsed = ( self.elapsed or 0 ) + elapsed
	
	if self.elapsed < 0.05 then return end
	self.elapsed = 0
	
	local gettime = GetTime()
	
	for guidspellid, data in pairs(dot_store) do
	
		if data then
			data[6] = data[5] - gettime
			if data[6] <= 0 then
				
				if ( data[2] - gettime ) < data[4] and ( data[2] - gettime ) > 0 then
					data[5] = gettime + ( data[2] - gettime )
					data[15] = ( data[2] - gettime )
					data[16] = data[15]/data[4]
				else
					data[5] = gettime + data[4]
					data[15] = data[4]
					data[16] = 1
				end
				data[6] = data[5] - gettime
				data[3] = data[3] - 1
			end
			data[6] = data[5] - gettime
		end
	end
end

local onupdate = CreateFrame("Frame")
onupdate:SetScript("OnUpdate", OnUpdate)

function C:RegisterDot(guid, spellid, starttime, endtime, cp, destName)
	
	if not dot_store[guid..spellid] then
		
		dot_store[guid..spellid] = { nil, nil, nil, nil, nil, nil, nil, nil, nil, nil }
		dot_store[guid..spellid][1] = starttime or GetTime()												-- starttime
		dot_store[guid..spellid][2]	= endtime or dot_store[guid..spellid][1] + dots_info[spellid][2]		-- endtime
		dot_store[guid..spellid][3] = dots_info[spellid][2]/dots_info[spellid][1]							-- ticks amount
		dot_store[guid..spellid][4] = dots_info[spellid][1]													-- ticks time
		dot_store[guid..spellid][5] = dot_store[guid..spellid][1] + dots_info[spellid][1]					-- time to next tick
		dot_store[guid..spellid][6] = dots_info[spellid][1]													-- displayed duration
		dot_store[guid..spellid][7] = true																	-- show
		dot_store[guid..spellid][8] = dots_info[spellid][2]													-- default amount
		
		dot_store[guid..spellid][13] = guid																	-- guid
		dot_store[guid..spellid][14] = spellid																-- spellid
		dot_store[guid..spellid][15] = dots_info[spellid][1]												-- tick duration
		dot_store[guid..spellid][16] = 1																	-- tick partiall coeff
		dot_store[guid..spellid][17] = cp																	-- tick partiall coeff
		dot_store[guid..spellid][18] = destName
		
		self:UpdateDamageMods(guid, spellid, destName)
		
		self:UpdateMultiDot()
	end
end

function C:RefreshRegisterDot(guid, spellid, cp, dstName)
	
	if dot_store[guid..spellid] then
		local starttime = GetTime()
		local endtime = starttime + dots_info[spellid][3]		
		local pandemia = 0
		
		if dots_info[spellid][5] > 0 then
			if dot_store[guid..spellid][2] > starttime then
				pandemia = dot_store[guid..spellid][2] - starttime
			end
			
			if pandemia > dots_info[spellid][2]*0.3 then
				pandemia = dots_info[spellid][2]*0.3
			end
		end
	
		dot_store[guid..spellid][1]	= starttime
		dot_store[guid..spellid][2]	= dot_store[guid..spellid][1] + dots_info[spellid][2] + pandemia
		
		local duration = ( dot_store[guid..spellid][2] - dot_store[guid..spellid][1] )
		
		dot_store[guid..spellid][3] = floor(duration/dots_info[spellid][1]) + 1								-- ticks amount
		
		dot_store[guid..spellid][17] = cp	
		
		self:UpdateDamageMods(guid, spellid, dstName)
		
		self:UpdateMultiDot()
	end
end

function C:UnregisterDot(guid, spellid)	
	if dot_store[guid..spellid] then
		dot_store[guid..spellid] = nil
		
		self:UpdateMultiDot()
	end
end

function C:GetMaxCurrentTime(guid, spellid)
	local maxtime, current = 0, 0
	
	if dot_store[guid..spellid] then
		local data = dot_store[guid..spellid]
		
		maxtime = data[15]
		current = data[6]
	end
	
	return maxtime, current
end

-- CLEU ---
local cp_bycast = 0

local spellAnonce = {
	
	

}

local placeHolder = {
	[77764] = 77764,
	[77761] = 77764,
}

-- 77764 	Тревожный рев
-- 77761	Тревожный рев
do
	local SendChatMessage = SendChatMessage
	local IsInRaid, IsInGroup = IsInRaid, IsInGroup
	local LE_PARTY_CATEGORY_INSTANCE = LE_PARTY_CATEGORY_INSTANCE
	local LE_PARTY_CATEGORY_HOME = LE_PARTY_CATEGORY_HOME
	
	function C.ChatMessage(msg, chat, target)
		
		if chat == "RAID_WARNING" then
			SendChatMessage(msg, chat)
		elseif chat == "PARTY" then
			SendChatMessage(msg, ( IsInGroup(LE_PARTY_CATEGORY_INSTANCE) or IsInRaid(LE_PARTY_CATEGORY_INSTANCE) ) and "INSTANCE_CHAT" or chat)
		elseif chat == "GUILD" then
			SendChatMessage(msg, chat)
		elseif chat == "RAID" then		
			SendChatMessage(msg, ( IsInGroup(LE_PARTY_CATEGORY_INSTANCE) or IsInRaid(LE_PARTY_CATEGORY_INSTANCE) ) and "INSTANCE_CHAT" or chat)
		elseif chat == "WHISPER" and target then		
			SendChatMessage(msg, chat, nil, target)
		elseif chat == "SAY" or chat == "YELL" then 
			SendChatMessage(msg, chat)
		else
			local chatType = "SAY"
			if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) or IsInRaid(LE_PARTY_CATEGORY_INSTANCE) then
				chatType = "INSTANCE_CHAT"
			elseif IsInRaid(LE_PARTY_CATEGORY_HOME) then
				chatType = "RAID"
			elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
				chatType = "PARTY"
			end
			
			if chatType == "PRINT" then
				print(msg)
			else
				SendChatMessage(msg, chatType)
			end
		end
	end
end

local numToChat = {
	
	false, 
	'PARTY', 
	'RAID', 
	'WHISPER', 
	'YELL', 
	'SAY',

}

function C:DoAnonce(event, spellID, target, source, extraSpellID, text)

	local spellIDph = placeHolder[spellID] or spellID
	
	if C.db.profile.anonse.spells[spellIDph] and C.db.profile.anonse.spells[spellIDph].on then
		
		if spellIDph == 93985 and not C.db.profile.anonse.spells[spellIDph].iffailed and not extraSpellID then 
			return
		end
		
		local msg = C.db.profile.anonse.spells[spellIDph].text
		
		msg = gsub(msg, "%%spell", GetSpellLink(spellID) or "")
		msg = gsub(msg, "%%extraspell", extraSpellID and GetSpellLink(extraSpellID) or L["провалено"])
		msg = gsub(msg, "%%target", target or UNKNOWN)
		msg = gsub(msg, "%%source", source or UNKNOWN)

		self.ChatMessage(msg, numToChat[C.db.profile.anonse.spells[spellIDph].chat], C.db.profile.anonse.spells[spellIDph].target)
	end
end

local kickqueue = CreateFrame("Frame")
kickqueue.elapsed = 0
kickqueue:SetScript("OnUpdate", function(self, elapsed)
	self.elapsed = self.elapsed + elapsed
	
	if self.elapsed < 0.2 then return end
	self.elapsed = 0
	self:Hide()
	
	C:DoAnonce(event, self.spellID, self.target, self.source, self.extraSpell, self.text)	
end)

local function DelayCastKick(spellID, target, source)
	kickqueue.elapsed = 0
	kickqueue.spellID = spellID
	kickqueue.target = target
	kickqueue.source = source
	kickqueue.kicked = false
	kickqueue.extraSpell = nil
	kickqueue:Show()
end

local function SetCastKicked(extraSpell)
	kickqueue.kicked = true
	kickqueue.extraSpell = extraSpell
	kickqueue.elapsed = 1
end

local missType = {
	["ABSORB"] = false,
	["BLOCK"] = false,
	["DEFLECT"] = false,
	["DODGE"] = false,
	["EVADE"] = false,
	["IMMUNE"] = true,
	["MISS"] = true,
	["PARRY"] = true,
	["REFLECT"] = false,
	["RESIST"] = false,
}

local function GetRakeDamage(critical)
	local tigrinie_neistvo = UnitAura("player", tigrinoe_name) 	 -- 15%
	local dikiy_rev		   = UnitAura("player", dikiyrev_name) 	 -- 30%, 40% for WoD
	local krovavie_kogti   = UnitAura("player", krovaviekogti_name) or ( hideauraTime2 > GetTime() ) -- 30%
	
	local versality = 1 + ( GetCombatRatingBonus(CR_VERSATILITY_DAMAGE_DONE) * 0.01 )
	local mastery = 1 + ( GetMastery()*2 * 0.01 ) -- 3.13 for WoD
	local dmg = rakeDamage*UnitAttackPower('player')
	local crit = 1
	local dmg_buff = 1
	if critical then
		crit = 2
	end
	
	if tigrinie_neistvo then 
		dmg_buff = dmg_buff * 1.15
	end
	if dikiy_rev then 
		dmg_buff = dmg_buff * 1.25 -- 1.4 for WoD
	end
	if krovavie_kogti then 
		dmg_buff = dmg_buff * 1.4
	end
	
	local tdmg = ceil(dmg*versality*mastery*2*crit*dmg_buff)
	local pogresh = tdmg*rakeDamagePog
	return tdmg, tdmg+pogresh, tdmg-pogresh
end

local soundTrottle = 0

local legendaryRingProc = {
	[187620] = true,
	[187616] = true,
	[187619] = true,
}

do
	local string_match = string.match
	function C.Erase(name)
		if not name then return name end
		local rname = string_match(name, "(.+)-") or name
		return rname
	end
end

function C:COMBAT_LOG_EVENT_UNFILTERED(event, ...)
	
	local timestamp, eventType, hideCaster,
			srcGUID, srcName, srcFlags, srcFlags2,
			dstGUID, dstName, dstFlags, dstFlags2,
			spellID, spellName, spellSchool, auraType, amount, extraSchool, extraType, blocked,absorbed,critical,glancing,crushing, isOffHand = ...
			
	--[==[
	if C.db.profile.others.anonceDDLMG and eventType == 'SPELL_AURA_APPLIED' and legendaryRingProc[spellID] and srcGUID == dstGUID then	
		local _, _, _, _, _, duration, endTime = UnitAura(dstName, spellName)			
		if duration and duration > 0 and endTime and endTime > 0 then			
			C.ChatMessage(format("%s %s %s", 'FDD >',  L['использует кольцо нанесения урона'], C.Erase(dstName) ))
		end
		return
	end
	
	if C.db.profile.others.anonceHEALLMG and eventType == 'SPELL_AURA_APPLIED' and srcGUID == dstGUID and spellID == 187618 then
		local _, _, _, _, _, duration, endTime = UnitAura(dstName, spellName)
		
		if duration and duration > 0 and endTime and endTime > 0 then	
			C.ChatMessage(format("%s %s %s", 'FDD >',  L['использует кольцо исцеления'], C.Erase(dstName) ))
		end
	end
	]==]
	
	if srcGUID ~= self.myGUID then

		if srcName == UnitName('player') then
			error('Wrong player guid: '..tostring(srcGUID or 'nil')..' and '..tostring(self.myGUID or 'nil'))
		end
	
		return 
	end

	
	--[==[
	if eventType == "SPELL_DAMAGE" then
		if spellID == 1822 then	
			local tdmg, pogresh1, pogresh2 = GetRakeDamage(critical)
			
			local realDamage = select(15, ...)
			
			if ( realDamage == tdmg ) or ( pogresh1 > realDamage and realDamage > pogresh2) then	
				if shadowmeldDebug then
					print("UPPED DOT DETECTED")
				end
				detectrakeBonus = true
				
		--		error("BUFF DOT DETECTED")
			else
				if shadowmeldDebug then
					print("FAILED TO DETECT", ( realDamage == tdmg ), ( pogresh1 > realDamage ), ( realDamage > pogresh2) )
					print("FAILED TO DETECT", realDamage, tdmg, pogresh1, pogresh2 )
					print("FAILED TO DETECT", glancing, crushing) 
				end
				detectrakeBonus = false
				
		--		error("BUFF DOT DETECTION FAILED "..tostring(( realDamage == tdmg )).." - "..tostring(( pogresh1 > realDamage )).." - "..tostring(( realDamage > pogresh2)).." - "..realDamage.." - "..tdmg.." - "..pogresh1 )
			end
			if shadowmeldDebug then
				print("T0", tdmg, pogresh, critical)
				print("T", GetTime(), "DOT DO DAMAGE", select(15, ...) , ( select(21, ...) and "crit" or ''), ( select(25, ...) and "MS" or ''))
			end
		end	
	end
	
	if eventType == "SPELL_PERIODIC_DAMAGE" then
		if spellID == glybokayrana_spid then	
	--		print("T", GetTime(), eventType, "DOT DO DAMAGE", select(15, ...) , ( select(21, ...) and "crit" or ''), ( select(25, ...) and "MS" or ''))
		end	
	end
	]==]

	if eventType == "SPELL_AURA_APPLIED" then	
		if spellID == glybokayrana_spid or spellID == vzbuchka_spid then
			C:RegisterDot(dstGUID, spellID, nil, nil, nil, dstName)
			
			if spellID == glybokayrana_spid then
		--		print("T", GetTime(), "DOT APPLY")
				
				detectrakeBonus = false
			end
			
		elseif spellID == razorvat_spid then
			C:RegisterDot(dstGUID, spellID, nil, nil, cp_bycast, dstName)
		elseif moonfire_spid == spellID then
			C:RegisterDot(dstGUID, spellID, nil, nil, nil, dstName)
		elseif spellID == 339 or spellID == 102359 then

			C:RegisterDot(dstGUID, spellID, nil, nil, nil, dstName)
		elseif dikiyrev_spid == spellID then
			SR_COMBO_POINTS = UnitPower('player', 4)
		end
	elseif eventType == "SPELL_CAST_SUCCESS" then
		if spellID == 106839 then
			DelayCastKick(93985, dstName, srcName)
		elseif spellID ~= 20484 then
			C:DoAnonce(eventType, spellID, dstName, srcName)
		end
	elseif eventType == "SPELL_INTERRUPT" then
		local extraSpellID, extraSpellName, extraSchool = select(15, ...)
		SetCastKicked(extraSpellID)		
	elseif eventType == "SPELL_RESURRECT" and spellID == 20484 then	
		C:DoAnonce(eventType, spellID, dstName, srcName)
		
	elseif eventType == "SPELL_AURA_REFRESH" then		
		if spellID == glybokayrana_spid or spellID == vzbuchka_spid then
			C:RefreshRegisterDot(dstGUID, spellID,nil, dstName)
		--	print("T6", eventType, spellID, spellName, cp_bycast)
			
			if spellID == glybokayrana_spid then
			--	print("T", GetTime(), "DOT REFRESH")
				
				detectrakeBonus = false
			end
			
		elseif spellID == razorvat_spid then
			C:RefreshRegisterDot(dstGUID, spellID, cp_bycast, dstName)
		--		print("T6", eventType, spellID, spellName, cp_bycast)
		elseif moonfire_spid == spellID then
			C:RefreshRegisterDot(dstGUID, spellID,nil, dstName)
		elseif spellID == 339 or spellID == 102359 then
		
			C:RefreshRegisterDot(dstGUID, spellID, nil, dstName)
		end
	elseif eventType == "SPELL_AURA_REMOVED" then
		if spellID == glybokayrana_spid or spellID == razorvat_spid or spellID == vzbuchka_spid then
			C:UnregisterDot(dstGUID, spellID)
			
			if spellID == glybokayrana_spid then
			--	print("T", GetTime(), "DOT END")
			end
			
		elseif moonfire_spid == spellID then
			C:UnregisterDot(dstGUID, spellID)
		elseif spellID == 339 or spellID == 102359 then

			C:UnregisterDot(dstGUID, spellID)
		elseif spellID == stealth_spid or spellID == 102547 then		
			hideauraTime = GetTime()+trottle1
		elseif spellID == krovaviekogti_spid then
			hideauraTime2 = GetTime()+trottle1
		elseif spellID == 58984 then
			hideauraTime3 = GetTime()+trottle1
		end
	elseif spellID ~= 163505 and C.db.profile.others.playSound and eventType == "SPELL_MISSED" and missType[auraType] then
		if  ( GetTime() > soundTrottle ) then
			soundTrottle = GetTime() + 1			
			local willplay, handler = PlaySoundFile(C.SharedMedia:Fetch("sound", C.db.profile.others.playSoundFile), "MASTER")	
		end
	end
end

-- UCS --
--[==[
function C:UNIT_SPELLCAST_SUCCEEDED(event, unitID, spell, rank, lineID, spellID)
	if true then return end
	if unitID ~= "player" then return end

	if UnitGUID("target") then
		if spellID == 1822 then
			C:RefreshRegisterDot(UnitGUID("target"), glybokayrana_spid,nil, UnitName("target"))
			print("T", spell, unitID, spellID)
			C:UpdateVisible("target")
		elseif spellID == vzbuchka_spid then
			C:RefreshRegisterDot(UnitGUID("target"), vzbuchka_spid,nil, UnitName("target"))
			print("T", spell, unitID, spellID)
			C:UpdateVisible("target")
		elseif spellID == razorvat_spid then
			C:RefreshRegisterDot(UnitGUID("target"), razorvat_spid, cp_bycast, UnitName("target"))
			print("T", spell, unitID, spellID)
			C:UpdateVisible("target")
		end
	end
end
]==]
-- UA ---

function C:UNIT_AURA(event, unit)
	
	if unit ~= "target" and unit ~= "player" then return end
	
	C:UpdateVisible(unit)
end

-- MainFrame Visability

function C:UpdateMainFrameVisability()
	if options.show_in_combat then
		if not UnitAffectingCombat("player") then
			self.movingFrame:Hide()
			C:ToggleCooldownBar("Hide")
			return
		end
	end
	
	if options.show_on_target then
		if not UnitExists("target") then
			self.movingFrame:Hide()
			C:ToggleCooldownBar("Hide")
			return
		end
	end
	
	if options.show_only_catform or C.only_in_cantForm then
		if GetForm() ~= CAT_FORM then
			self.movingFrame:Hide()
			C:ToggleCooldownBar("Hide")
			C:UpdateMultiDot()
			return
		end
	end
	
	C.movingFrame:Show()	
	if C.only_in_cantForm then
		C:ToggleCooldownBar("Hide")
	else
		C:ToggleCooldownBar("Show")
	end
	
	C:UpdateMultiDot()
end


-- TargetChange --

function C:PLAYER_TARGET_CHANGED(event, unit)
	if C.disable_addon then
		C.movingFrame:Hide()
		C:ToggleCooldownBar("Hide")
		return
	end
	
	C:UpdateMainFrameVisability()
	
	C:UpdateVisible("target")
	C:UpdateMultiDot()
end

function C:PLAYER_FOCUS_CHANGED(event, unit)
	
	
--	C:UpdateVisible("focus")
end

local combopoits_str = {	
	"|cffffff00"..RANGE_INDICATOR.."|r",
	"|cffffff00"..RANGE_INDICATOR.."|r|cffffff00"..RANGE_INDICATOR.."|r",
	"|cffffff00"..RANGE_INDICATOR.."|r|cffffff00"..RANGE_INDICATOR.."|r|cffffff00"..RANGE_INDICATOR.."|r",
	"|cffffff00"..RANGE_INDICATOR.."|r|cffffff00"..RANGE_INDICATOR.."|r|cffffff00"..RANGE_INDICATOR.."|r|cffffff00"..RANGE_INDICATOR.."|r",
}

local function updateGlow(self, elapsed)
	self.elapsed = ( self.elapsed or 0 ) + ( elapsed * self.dir )
	if self.elapsed > 1 then
		self.dir = -1.7
	elseif self.elapsed <= 0 then
		self.dir = 1.7
	end

	self:SetAlpha(self.elapsed)
end

local function updateGlowEnergy(self, elapsed)
	self.elapsed = ( self.elapsed or 0 ) + ( elapsed * self.dir )
	if self.elapsed > 1 then
		self.dir = -1.7
	elseif self.elapsed <= 0 then
		self.dir = 1.7
	end
	
	if self.endTime-GetTime() < 3 then
		C.movingFrame.energybar.glowIndicatorText:SetText(format("%.1f ", self.endTime-GetTime()))
	else
		C.movingFrame.energybar.glowIndicatorText:SetText(format("%.0f ", self.endTime-GetTime()))
	end
	
	if options.energybar.showglow then
		if options.energybar.animglow then
			C.movingFrame.energybar.glowIndicator:SetAlpha(self.elapsed)
		else
			C.movingFrame.energybar.glowIndicator:SetAlpha(1)
		end
	else
		C.movingFrame.energybar.glowIndicator:SetAlpha(0)
	end
end

local clearCastAnim = CreateFrame("Frame")
clearCastAnim.elapsed = 0
clearCastAnim.dir = -1.7
clearCastAnim.endTime = 0
clearCastAnim.work = true
clearCastAnim.Start = function(self, endTime, duration)
	self.endTime = endTime
	if self.work then return end
	C:UNIT_POWER_FREQUENT(event, "player")
	self.work = true
	self:Show()
	C.movingFrame.energybar.glowIndicatorText:Show()
end
clearCastAnim.Reset = function(self)
	if not self.work then return end
	C:UNIT_POWER_FREQUENT(event, "player")
	self.work = false
	C.movingFrame.energybar.glowIndicator:SetAlpha(0)
	self.elapsed = 0
	self.dir = -1.7
	self:Hide()	
	C.movingFrame.energybar.glowIndicatorText:Hide()
end
clearCastAnim:SetScript("OnUpdate", updateGlowEnergy)
clearCastAnim:Hide()

function C:UpdateVisible(unit)
	OnUpdateFrames.elapsed = 0
	
	for i=1, #self.movingFrame.icons do
		
		self.movingFrame.icons[i].shown = false

		local ind = 1
		
		while ( true ) do
			local name, _, icon, _, _, duration, expirationTime, _, _, _, spellId = UnitAura("target", ind, "PLAYER|HARMFUL")
			
			if not name then
				break;
			end
	
			if spellId == self.movingFrame.icons[i].spellID then
		
				local guid = UnitGUID("target")
				local spellid = self.movingFrame.icons[i].spellID
				
				C:RegisterDot(guid, spellid, expirationTime-duration, expirationTime)
				
				local cp = 0
				
				if dot_store[guid..spellid] then
					
					if hookrake and spellId == 155722 then
						
						if duration > 15 and duration < 19.5 then
							
							expirationTime = expirationTime + 3
						end
					end
					dot_store[guid..spellid][1] = expirationTime-duration or GetTime()												-- starttime
					dot_store[guid..spellid][2]	= expirationTime or dot_store[guid..spellid][1] + dots_info[spellid][2]		-- endtime
					
					cp = dot_store[guid..spellid][17]
				end
				
				self.movingFrame.icons[i].shown = true
				self.movingFrame.icons[i].icon:SetDesaturated(false)
				self.movingFrame.icons[i].guid = guid
				if self.movingFrame.icons[i].cooldown._start ~= expirationTime-duration or
					self.movingFrame.icons[i].cooldown._duration ~= duration then
					
					self.movingFrame.icons[i].cooldown:SetCooldown(expirationTime-duration, duration)
					self.movingFrame.icons[i].cooldown._start = expirationTime-duration
					self.movingFrame.icons[i].cooldown._duration = duration
				end
				self.movingFrame.icons[i].icon2:Show()
				
				if C.db.profile.show_ticks then
					self.movingFrame.icons[i].statusbar:Show()
				end
				self.movingFrame.icons[i]:SetAlpha(1)
				
				if options.icons.showcp and cp and cp < 5 and cp > 0 then
					self.movingFrame.icons[i].cprip:SetText(combopoits_str[cp])
					self.movingFrame.icons[i].cprip:Show()
				else
					self.movingFrame.icons[i].cprip:Hide()
				end
			end
			
			ind = ind + 1
		end
		
		ind = 1
		
		while ( true ) do
			local name, _, icon, _, _, duration, expirationTime, _, _, _, spellId = UnitAura("player", ind, "PLAYER|HELPFUL")
			
			if not name then
				break;
			end
	
			if name == self.movingFrame.icons[i].spellName then

				local guid = UnitGUID("player")
				local spellid = self.movingFrame.icons[i].spellID
				
				self.movingFrame.icons[i].shown = true
				self.movingFrame.icons[i].icon:SetDesaturated(false)
				self.movingFrame.icons[i].guid = guid

				if self.movingFrame.icons[i].cooldown._start ~= expirationTime-duration or
					self.movingFrame.icons[i].cooldown._duration ~= duration then
					
					self.movingFrame.icons[i].cooldown:SetCooldown(expirationTime-duration, duration)
					self.movingFrame.icons[i].cooldown._start = expirationTime-duration
					self.movingFrame.icons[i].cooldown._duration = duration
				end
				
				
				self.movingFrame.icons[i].cooldown:Show()
				self.movingFrame.icons[i].icon2:Show()
				self.movingFrame.icons[i].statusbar:Hide()
				self.movingFrame.icons[i]:SetAlpha(1)
				self.movingFrame.icons[i].cprip:Hide()
			end
			
			ind = ind + 1
		end
		
		local clearCast, _, _, _, _, duration, expirationTime = UnitAura("player", clearcast_name, nil, "PLAYER|HELPFUL")
		
		CLEAR_CAST_FIND = clearCast
		if clearCast then
			clearCastAnim:Start(expirationTime)
		else
			clearCastAnim:Reset()
		end

		-- 135700
		
		if not self.movingFrame.icons[i].shown then
			self.movingFrame.icons[i].statusbar:SetValue(0)
			self.movingFrame.icons[i]:RestoreTexture()		
			self.movingFrame.icons[i].icon:SetDesaturated(options.icons.desaturated)
			self.movingFrame.icons[i].icon:SetVertexColor(1, 1, 1, 1)
			self.movingFrame.icons[i].cooldown:Hide()
			self.movingFrame.icons[i].cooldown._start = 0
			self.movingFrame.icons[i].cooldown._duration = 0
			self.movingFrame.icons[i].icon2:Hide()
			self.movingFrame.icons[i].statusbar:Hide()
			self.movingFrame.icons[i].glow:Hide()
			self.movingFrame.icons[i]:SetAlpha(options.icons.alpha_outof_combat or 0.8)
			self.movingFrame.icons[i].cprip:Hide()
			self.movingFrame.icons[i].glow.elapsed = 0
		end
	end
end

local TOTAL_WIDTH = 200

local idin = 0
local IconCounter = 0

function C:AddIcon(spellid, parent)
	IconCounter = IconCounter+1
	local f = CreateFrame("Frame", parent:GetName().."Icon"..IconCounter, parent)
	
--	print('T', IconCounter, f:GetName(), 'CreateIcon')
	f:SetSize(TOTAL_WIDTH/3, TOTAL_WIDTH/3)
	f.spellID = spellid
	
	local spellName, _, spellIcon = GetSpellInfo(spellid)
	f.spellName = spellName
	

	self:AddMoving(f)
	
	local icon = f:CreateTexture(nil, "BACKGROUND")
	icon:SetAllPoints()
	icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)
	icon:SetTexture(spellIcon)

	f.icon2 = f:CreateTexture(nil, "BACKGROUND", nil, 1)
	f.icon2:SetAllPoints()
	f.icon2:SetColorTexture(0, 0, 0, 1)
	
	f.backdrop = CreateFrame("Frame", nil, f)
	f.backdrop:SetFrameStrata("LOW")
	
	f.bg = f.backdrop:CreateTexture(nil, "BACKGROUND", nil, -2)
	f.bg:SetPoint("TOPLEFT", f, "TOPLEFT", -1, 1)
	f.bg:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", 1, -1)
	f.bg:SetColorTexture(0,0,0,1)
	
	f.glow = CreateFrame("Frame", nil, f)
	f.glow:SetBackdrop({
		edgeFile = "Interface\\ChatFrame\\ChatFrameBackground",
		edgeSize = 3,
	})
	f.glow:SetBackdropBorderColor(1, 1, 0, 1)
	f.glow:SetPoint("TOPLEFT", 1, -1)
	f.glow:SetPoint("BOTTOMRIGHT", -1, 1)	
	f.glow.dir = -1.7
	
	f.RestoreTexture = function(self)
		if self.spellID ~= razorvat_spid then return end
		self.icon:SetTexture(razorvat_texture)		
	end
	
	local cd = CreateFrame("Cooldown", f:GetName().."Cooldown", f, "CooldownFrameTemplate")
	cd.parent = f
	cd:SetAllPoints()
	cd.noCooldownCount = true
	cd:SetHideCountdownNumbers(true)
	cd:SetReverse(true)
	cd:SetScript("OnUpdate", function(self, elapsed)
		local parent = self.parent
		local guid = parent.guid
		local spellid = parent.spellID
		
		local maxtime, current = C:GetMaxCurrentTime(guid, spellid)
		local curperhp = 0
		
		if spellid == razorvat_spid then
			curperhp = UnitHealth("target")*100/UnitHealthMax("target")

			if curperhp < 25 and parent.shown then
				parent.icon:SetTexture(fb_texture)
			else
				parent.icon:SetTexture(razorvat_texture)
			end
		end
		
		
		parent.statusbar:SetMinMaxValues(0, maxtime)
		parent.statusbar:SetValue(current)
		
		local data = dot_store[guid..spellid]
		
		local numb = ((self._start + self._duration) - GetTime())
		
		if numb > 3 then
			parent.timer:SetText(format(" %.0f ", ceil(numb)))
		else	
			if C.db.profile.icons.time_format == 2 then
				parent.timer:SetText(format(" %.1f ", ( numb >= 0 and numb or 0.0)))
			else
				parent.timer:SetText(format(" %.0f ",  ceil(( numb >= 0 and numb or 0.0))))
			end
		end
		
		if spellid == dikiyrev_spid then	
			local baseDur = 8 + ((SR_COMBO_POINTS-1) * 4)
			if numb < baseDur*0.3 then			
				parent.glow:Show()
			else
				parent.glow.elapsed = 0
				parent.glow.dir = 1.7
				parent.glow:Hide()	
			end
		elseif dots_info[spellid] and numb < dots_info[spellid][5] then
			parent.glow:Show()
		else
			parent.glow.elapsed = 0
			parent.glow.dir = 1.7
			parent.glow:Hide()			
		end
		
		if not data then 
			parent.power1:SetText("")
			parent.power2:SetText("")			
			return 
		end
		
		local v1, v2 = C:GetDotBuffValue(guid, spellid) -- total cur, total
		-- v1 то что уже есть v2 то что будет
		--v2 = v2  --* data[16]
		
		local current_t = blank
		local current_d = 0
		local current_d1 = 0
		
		if v1 and v2 then
			
			if v1 > v2 and (v1 - v2 ) > ( options.dotpowerspike*0.01) then 
				current_t = 1
			elseif v2 > v1 then
				current_t = -1
			else
				current_t = 0
			end
			
			if options.relative_numbers then
				current_d = v1*100/v2
				current_d1 = v2*100
			else
				current_d = v1*100
				current_d1 = v2*100
			end
		end

		parent.icon:SetVertexColor(1, 1, 1, 1)
		
		if current_t == 0 then			
			if options.icons.icon_color_values then
				parent.icon:SetVertexColor(options.icons.same_color[1], options.icons.same_color[2], options.icons.same_color[3], options.icons.same_color[4])
			end
		elseif current_t == 1 then
			if options.icons.icon_color_values then
				parent.icon:SetVertexColor(options.icons.better_color[1], options.icons.better_color[2], options.icons.better_color[3], options.icons.better_color[4])
			end		
		elseif current_t == -1 then
			if options.icons.icon_color_values then
				parent.icon:SetVertexColor(options.icons.worse_color[1], options.icons.worse_color[2], options.icons.worse_color[3], options.icons.worse_color[4])
			end	
		end
			
		if options.icons.revert_text_coloring then
			parent.power1:SetTextColor(1, 1, 1, 1)
			if current_t == 0 then			
				if options.icons.text_color_values then		
					parent.power2:SetTextColor(options.icons.same_color[1], options.icons.same_color[2], options.icons.same_color[3], options.icons.same_color[4])
				end
			elseif current_t == 1 then			
				if options.icons.text_color_values then		
					parent.power2:SetTextColor(options.icons.better_color[1], options.icons.better_color[2], options.icons.better_color[3], options.icons.better_color[4])
				end
			elseif current_t == -1 then			
				if options.icons.text_color_values then		
					parent.power2:SetTextColor(options.icons.worse_color[1], options.icons.worse_color[2], options.icons.worse_color[3], options.icons.worse_color[4])
				end
			end
		else
			parent.power2:SetTextColor(1, 1, 1, 1)
			
			if current_t == 0 then			
				if options.icons.text_color_values then		
					parent.power1:SetTextColor(options.icons.same_color[1], options.icons.same_color[2], options.icons.same_color[3], options.icons.same_color[4])
				end
			elseif current_t == 1 then			
				if options.icons.text_color_values then		
					parent.power1:SetTextColor(options.icons.better_color[1], options.icons.better_color[2], options.icons.better_color[3], options.icons.better_color[4])
				end
			elseif current_t == -1 then			
				if options.icons.text_color_values then		
					parent.power1:SetTextColor(options.icons.worse_color[1], options.icons.worse_color[2], options.icons.worse_color[3], options.icons.worse_color[4])
				end
			end
		end
		
		parent.power1:SetFormattedText("%.0f", current_d)
		parent.power2:SetFormattedText("%.0f", current_d1)
		
		self.elapsed = ( self.elapsed or 0 ) + elapsed
		
		if self.elapsed < 0.1 then return end
			self.elapsed = 0
	end)

	local power = cd:CreateFontString(nil, "OVERLAY")
	power:SetFont(STANDARD_TEXT_FONT, GLOBAL_FONT_SIZE, "OUTLINE")
	power:SetPoint("TOPLEFT", cd, "TOPLEFT", -20, 0)
	power:SetPoint("BOTTOMRIGHT", cd, "BOTTOMRIGHT", 20, 0)
	power:SetJustifyH("CENTER")
	power:SetJustifyV("BOTTOM")
	power:SetText("Power")
	
	local power2 = cd:CreateFontString(nil, "OVERLAY")
	power2:SetFont(STANDARD_TEXT_FONT, GLOBAL_FONT_SIZE, "OUTLINE")
	power2:SetPoint("TOPLEFT", cd, "TOPLEFT", -20, 0)
	power2:SetPoint("BOTTOMRIGHT", cd, "BOTTOMRIGHT", 20, 0)
	power2:SetJustifyH("CENTER")
	power2:SetJustifyV("BOTTOM")
	power2:SetText("Power")

	local cprip = cd:CreateFontString(nil, "OVERLAY")
	cprip:SetFont("Fonts\\ARIALN.TTF", 18, "OUTLINE")
	cprip:SetPoint("TOPLEFT", cd, "TOPLEFT", -20, 5)
	cprip:SetPoint("BOTTOMRIGHT", cd, "BOTTOMRIGHT", 20, 0)
	cprip:SetJustifyH("CENTER")
	cprip:SetJustifyV("TOP")
	cprip:SetText("Power")
	
	local timer = cd:CreateFontString(nil, "OVERLAY")
	timer:SetFont(STANDARD_TEXT_FONT, GLOBAL_FONT_SIZE, "OUTLINE")
	timer:SetPoint("TOPLEFT", cd, "TOPLEFT", -10, 0)
	timer:SetPoint("BOTTOMRIGHT", cd, "BOTTOMRIGHT", 10, 0)
	timer:SetJustifyH("CENTER")
	timer:SetJustifyV("BOTTOM")
	timer:SetText("Power")
	
	local statusbar = CreateFrame("StatusBar", f:GetName().."StatusBar", cd)
	statusbar:SetSize(5, 9)
	statusbar:SetPoint("TOPLEFT", f, "BOTTOMLEFT", 0, -4)
	statusbar:SetPoint("TOPRIGHT", f, "BOTTOMRIGHT", 0, -4)
	statusbar:SetStatusBarTexture("Interface\\ChatFrame\\ChatFrameBackground")
	statusbar:SetMinMaxValues(0,3)
	statusbar:SetValue(2)
	
	statusbar.backdrop = CreateFrame("Frame", nil, statusbar)
	statusbar.backdrop:SetFrameStrata("LOW")
	
	statusbar.bg = statusbar.backdrop:CreateTexture(nil, "BACKGROUND")
	statusbar.bg:SetPoint("TOPLEFT", statusbar, "TOPLEFT", -1, 1)
	statusbar.bg:SetPoint("BOTTOMRIGHT", statusbar, "BOTTOMRIGHT", 1, -1)
	statusbar.bg:SetColorTexture(0,0,0,1)
	
	f.icon = icon
	f.cooldown = cd
	f.power1 = power
	f.power2 = power2
	f.timer = timer
	f.cprip = cprip
	f.statusbar = statusbar
	
	return f
end

local order_spell = {}
local unlockFrameList = {}

function C:UnlockFrames()
	
	if options.locked then
	
		for frame in pairs(unlockFrameList) do
			frame:EnableMouse(false)
		end
	else
		for frame in pairs(unlockFrameList) do
			frame:EnableMouse(true)
		end
	end
end

function C:AddMoving(frame)
	if true then return end
	
	unlockFrameList[frame] = true
	
	frame:EnableMouse(true)
	frame:SetMovable(true)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", function(self) C.movingFrame:StartMoving() end)
	frame:SetScript("OnDragStop", function(self) 
		C.movingFrame:StopMovingOrSizing()
		local x, y = C.movingFrame:GetCenter()
		local ux, uy = C.movingFrame:GetParent():GetCenter()

		options.pos = { floor(x - ux + 0.5),floor(y - uy + 0.5) }
	end)
	
end

function C:UpdateSortings()
	
	table.sort(options.ordering_spells.sort, function(x, y)
  
      if x.on == y.on then
         if x.sort == y.sort then
            return x.name > y.name
         else
            return x.sort < y.sort
         end
      else
         return x.on
      end
      
      return true
	end)
	
	wipe(order_spell)
	
	local framecount = 0
	
	show_moonfire_icon = false
	show_savage_roar_icon = false
	
	for i, data in ipairs(options.ordering_spells.sort) do
		
		options.ordering_spells.spellidtoid[data.name] = i
	
		if data.name == moonfire_spid then		
			if moonfire_talent and data.on then
				show_moonfire_icon = true
				framecount = framecount + 1			
				order_spell[framecount] = data.name			
			end
		elseif data.name == dikiyrev_spid then
			if savage_roar_talent and data.on then
				show_savage_roar_icon = true
				framecount = framecount + 1			
				order_spell[framecount] = data.name		
			end
		elseif data.on then
			framecount = framecount + 1
			order_spell[framecount] = data.name
		end
	end
	
end

local energyBreakPoints = { 25, 35, 40, 50 }

function C:InitFrames()
	
	local movingFrame = CreateFrame("Frame", AddOn.."MainFrame", UIParent)
	movingFrame:SetScale(1)
	movingFrame:SetSize(1, 1)
	movingFrame.icons = CreateFrame("Frame", nil, movingFrame)
	
	movingFrame:ClearAllPoints()
	movingFrame:SetPoint("CENTER", UIParent, "CENTER", options.pos[1], options.pos[2])
	
	self:AddMoving(movingFrame)

	local backdrop = CreateFrame("Frame", nil, movingFrame)
	backdrop:SetFrameStrata("LOW")
	movingFrame.backdrop = backdrop
	
	local bg = movingFrame.backdrop:CreateTexture(nil, "BACKGROUND")
	bg:SetPoint("TOPLEFT", movingFrame.backdrop, "TOPLEFT", -1, 1)
	bg:SetPoint("BOTTOMRIGHT", movingFrame.backdrop, "BOTTOMRIGHT", 1, -1)
	bg:SetColorTexture(0, 0, 0, 0)
	movingFrame.bg = bg
	
	self:UpdateSortings()
	
	for i, spellid in pairs(order_spell) do
		movingFrame.icons[i] = C:AddIcon(spellid, movingFrame)
	end

	movingFrame.cp = CreateFrame("Frame", nil, movingFrame)

	for i=1, 5 do
		
		movingFrame.cp[i] = CreateFrame("Frame", nil, movingFrame)
		movingFrame.cp[i]:SetSize((TOTAL_WIDTH-(3*5))/5, 14)
		
	--	self:AddMoving(movingFrame.cp[i])
		
		movingFrame.cp[i].texture = movingFrame.cp[i]:CreateTexture(nil, "ARTWORK", nil, 1)
		movingFrame.cp[i].texture:SetAllPoints()
		
		if i == 1 or  i == 2 then
			movingFrame.cp[i].texture:SetColorTexture(1, 1, 0, 1)
		elseif i == 3 or i == 4 then
			movingFrame.cp[i].texture:SetColorTexture(255/255, 171/255, 0, 1)
		else	
			movingFrame.cp[i].texture:SetColorTexture(255/255, 107/255, 0, 1)
		end

		movingFrame.cp[i].backdrop = CreateFrame("Frame", nil, movingFrame.cp[i])
		movingFrame.cp[i].backdrop:SetFrameStrata("LOW")
	
		movingFrame.cp[i].bg = movingFrame.cp[i].backdrop:CreateTexture(nil, "BACKGROUND", nil, -1)
		movingFrame.cp[i].bg:SetPoint("TOPLEFT", movingFrame.cp[i], "TOPLEFT", -1, 1)
		movingFrame.cp[i].bg:SetPoint("BOTTOMRIGHT", movingFrame.cp[i], "BOTTOMRIGHT", 1, -1)
		movingFrame.cp[i].bg:SetColorTexture(0,0,0,1)
		
		movingFrame.cp[i].bg2 = movingFrame.cp[i]:CreateTexture(nil, "BACKGROUND", nil, 1)
		movingFrame.cp[i].bg2:SetAllPoints()
		movingFrame.cp[i].bg2:SetColorTexture(1,0,0,1)
	
	end
	
	local energybar = CreateFrame("StatusBar", movingFrame:GetName().."StatusBarEnergy", movingFrame)
	energybar:SetSize(100, 9)
	energybar:SetPoint("CENTER", movingFrame, "CENTER", 0, 0)
	
--	self:AddMoving(energybar)
	
	energybar:SetStatusBarTexture("Interface\\ChatFrame\\ChatFrameBackground")
	energybar:SetMinMaxValues(0,100)
	energybar:SetValue(50)
	
	energybar.backdrop = CreateFrame("Frame", nil, energybar)
	
	energybar.bg = energybar:CreateTexture(nil, "BACKGROUND", nil, 0)
	energybar.bg:SetPoint("TOPLEFT", energybar, "TOPLEFT", -1, 1)
	energybar.bg:SetPoint("BOTTOMRIGHT", energybar, "BOTTOMRIGHT", 1, -1)
	energybar.bg:SetColorTexture(0,0,0,1)
	
	energybar.bg2 = energybar:CreateTexture(nil, "BACKGROUND", nil, 1)
	energybar.bg2:SetAllPoints()
	energybar.bg2:SetColorTexture(1,0,0,1)
	
	energybar.breakp = {}
	
	for i=1, #energyBreakPoints do
	
		energybar.breakp[i] = energybar:CreateTexture(nil, "OVERLAY", nil, 1)
		energybar.breakp[i].parent = energybar
		energybar.breakp[i].val = energyBreakPoints[i]
		energybar.breakp[i]:SetSize(1,1)
		energybar.breakp[i]:SetPoint("TOP", energybar, "TOP", 0, 0)
		energybar.breakp[i]:SetPoint("BOTTOM", energybar, "BOTTOM", 0, -0)
		energybar.breakp[i]:SetColorTexture(0, 0, 0, 0.9)
		energybar.breakp[i]:Hide()
		energybar.breakp[i].Update = function(self)
			local width = self.parent:GetWidth()
			local minEnergy, maxEnergy = self.parent:GetMinMaxValues()
			local pos = floor(width*self.val*0.01*(100/maxEnergy))
			local color = "threshold_color"
			if self.parent:GetValue() < self.val then
				color = "threshold_color2"
			end
			
			self:SetColorTexture(C.db.profile.energybar[color][1], C.db.profile.energybar[color][2], C.db.profile.energybar[color][3], C.db.profile.energybar[color][4])
			self:SetWidth(C.db.profile.energybar.threshold_width)
			
			self:SetPoint("LEFT", self.parent, "LEFT", pos, 0)
		end
	end
	
	energybar.glowIndicator = CreateFrame("Frame", nil, energybar)
	energybar.glowIndicator:SetFrameStrata("LOW")
	energybar.glowIndicator:SetBackdrop( {	
 		edgeFile = "Interface\\AddOns\\FeralDotDamage\\glow", edgeSize = 3,
 		insets = {left = 5, right = 5, top = 5, bottom = 5},
 	})		
	energybar.glowIndicator:SetBackdropBorderColor(0, 1, 0, 1)
	energybar.glowIndicator:SetScale(3.5)
	energybar.glowIndicator:SetPoint("TOPLEFT", energybar, "TOPLEFT", -3, 3)
	energybar.glowIndicator:SetPoint("BOTTOMRIGHT", energybar, "BOTTOMRIGHT", 3, -3)
	energybar.glowIndicator:SetAlpha(0)
	
	energybar.glowIndicatorText = energybar.backdrop:CreateFontString(nil, "OVERLAY")
	energybar.glowIndicatorText:SetFont(STANDARD_TEXT_FONT, GLOBAL_FONT_SIZE, "OUTLINE")
	energybar.glowIndicatorText:SetPoint("RIGHT", energybar, "RIGHT", 0, 0)
--	energybar.glowIndicatorText:SetWidth(20)
	energybar.glowIndicatorText:SetJustifyH("CENTER")
	energybar.glowIndicatorText:SetJustifyV("CENTER")
	energybar.glowIndicatorText:SetText("")
	energybar.glowIndicatorText:Hide()
	
	
	energybar.spark = energybar:CreateTexture(nil, "OVERLAY", nil, 3)
	energybar.spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
	energybar.spark:SetAlpha(1)
	energybar.spark:SetWidth(16)		
	energybar.spark:SetHeight(1)
	energybar.spark:Hide()
	energybar.spark:SetBlendMode('ADD')
	energybar.spark:SetPoint("LEFT",energybar:GetStatusBarTexture(),"RIGHT",-8,0)
	energybar.spark:SetPoint("TOP", energybar, "TOP",0,10)
	energybar.spark:SetPoint("BOTTOM", energybar, "BOTTOM",0,-10)
	
	local eamount = energybar.backdrop:CreateFontString(nil, "OVERLAY")
	eamount:SetFont(STANDARD_TEXT_FONT, GLOBAL_FONT_SIZE, "OUTLINE")
	eamount:SetPoint("TOPLEFT", energybar, "TOPLEFT", -20, 0)
	eamount:SetPoint("BOTTOMRIGHT", energybar, "BOTTOMRIGHT", 20, 0)
	eamount:SetJustifyH("CENTER")
	eamount:SetJustifyV("BOTTOM")
	eamount:SetText("EAmount")
	energybar.text = eamount
	
	movingFrame.energybar = energybar
	
	local manabar = CreateFrame("StatusBar", movingFrame:GetName().."StatusBarMana", movingFrame)
	manabar:SetSize(100, 9)
	manabar:SetPoint("CENTER", movingFrame, "CENTER", 0, 0)
	manabar:SetStatusBarTexture("Interface\\ChatFrame\\ChatFrameBackground")
	manabar:SetMinMaxValues(0,100)
	manabar:SetValue(50)
	manabar:SetStatusBarColor(0.2, 0.2, 1, 1)
	
	manabar.bg2 = manabar:CreateTexture(nil, "BACKGROUND", nil, 1)
	manabar.bg2:SetAllPoints()
	manabar.bg2:SetColorTexture(1,0,0,1)
	
--	self:AddMoving(manabar)
	
	manabar.backdrop = CreateFrame("Frame", nil, manabar)

	manabar.bg = manabar:CreateTexture(nil, "BACKGROUND", nil, 0)
	manabar.bg:SetPoint("TOPLEFT", manabar, "TOPLEFT", -1, 1)
	manabar.bg:SetPoint("BOTTOMRIGHT", manabar, "BOTTOMRIGHT", 1, -1)
	manabar.bg:SetColorTexture(0,0,0,1)
	
	local mamount = manabar.backdrop:CreateFontString(nil, "OVERLAY")
	mamount:SetFont(STANDARD_TEXT_FONT, GLOBAL_FONT_SIZE, "OUTLINE")
	mamount:SetPoint("TOPLEFT", manabar, "TOPLEFT", -20, 0)
	mamount:SetPoint("BOTTOMRIGHT", manabar, "BOTTOMRIGHT", 20, 0)
	mamount:SetJustifyH("CENTER")
	mamount:SetJustifyV("BOTTOM")
	mamount:SetText("MAmount")
	manabar.text = mamount
	
	movingFrame.manabar = manabar

	self.movingFrame = movingFrame
	
	self:UpdateFramesStyle()
	
	self:UpdateVisible("target")
end

--[[

]]

function C:UpdateOrders()
	-- option.
	
	-- self.db.profile.ordering_spell
	
	self:UpdateSortings()
	
--	print('T', 'UpdateOrders')
	
	for i=1, #self.movingFrame.icons do
		self.movingFrame.icons[i]:Hide()
		self.movingFrame.icons[i].disabled = true
	end
	
	for i, spellid in pairs(order_spell) do
		local f = self.movingFrame.icons[i] or C:AddIcon(spellid, self.movingFrame)
		f.spellID = spellid
		local spellName, _, spellIcon = GetSpellInfo(spellid)
		
		f.spellName = spellName
		f.icon:SetTexture(spellIcon)
		f.disabled = false
		f:Show()
	end
	
	self:UpdateFramesStyle()
end

local positionCodes = {
	["TOP;CENTER"] 		= { 'TOP', 'TOP' }, --L["Сверху"],
	["TOP;LEFT"] 		= { 'TOPLEFT', 'TOPLEFT'	}, --L["Слева вверху"],
	["TOP;RIGHT"] 		= { 'TOPRIGHT', 'TOPRIGHT'	}, --L["Справа вверху"],
	["CENTER;CENTER"] 	= { 'CENTER', 'CENTER'}, --L["Центр"],
	["BOTTOM;CENTER"] 	= { 'BOTTOM', 'BOTTOM'}, --L["Снизу"],
	["BOTTOM;LEFT"] 	= { 'BOTTOMLEFT', 'BOTTOMLEFT' }, --L["Слева внизу"],
	["BOTTOM;RIGHT"] 	= { 'BOTTOMRIGHT', 'BOTTOMRIGHT'}, --L["Справа внизу"],
	["CENTER;LEFT"] 	= { 'LEFT', 'LEFT' }, --L["По центру слева"],
	["CENTER;RIGHT"] 	= { 'RIGHT', 'RIGHT' }, --L["По центру справа"],
}
function C:UnpackPositionString(str)	
	local justifyV, justifyH = strsplit(";", str)
	return justifyV, justifyH, positionCodes[str][1], positionCodes[str][2]
end


function C:UpdateFramesStyle()
	local f = self.movingFrame
	
--	print('T', 'UpdateFramesStyle')
	
--	f:ClearAllPoints()
--	f:SetPoint("CENTER", UIParent, "CENTER", options.pos[1], options.pos[2])
	
	f:SetWidth(options.width)
	f:SetHeight(options.height)
	
	C:Mover(f, "FrameBackground")
	
	local opt = options.border
	local backdrop = f.backdrop
	local bg = f.bg
	
	backdrop:SetBackdrop({
		edgeFile = C.SharedMedia:Fetch("border", opt.texture),
		edgeSize = opt.size,
	})
	backdrop:SetBackdropBorderColor(opt.color[1], opt.color[2], opt.color[3], opt.color[4])
	backdrop:SetPoint("TOPLEFT", -opt.inset, opt.inset)
	backdrop:SetPoint("BOTTOMRIGHT", opt.inset, -opt.inset)
	
	bg:SetPoint("TOPLEFT", f, "TOPLEFT", -opt.bg_inset, opt.bg_inset)
	bg:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", opt.bg_inset, -opt.bg_inset)
	bg:SetColorTexture(opt.background[1], opt.background[2], opt.background[3], opt.background[4])

	local text = f.manabar.text 
	text:SetFont(C.SharedMedia:Fetch("font", options.font), options.fontsize, options.fontflag)
	text:SetJustifyH("CENTER")
	text:SetJustifyV("BOTTOM")
	text:SetShadowColor(options.shadow_color[1],options.shadow_color[2],options.shadow_color[3],options.shadow_color[4])
	text:SetShadowOffset(options.shadow_pos[1],options.shadow_pos[2])
	
	text = f.energybar.text
	text:SetFont(C.SharedMedia:Fetch("font", options.font), options.fontsize, options.fontflag)
	text:SetJustifyH("CENTER")
	text:SetJustifyV("BOTTOM")
	text:SetShadowColor(options.shadow_color[1],options.shadow_color[2],options.shadow_color[3],options.shadow_color[4])
	text:SetShadowOffset(options.shadow_pos[1],options.shadow_pos[2])
	
	f.energybar.glowIndicatorText:SetFont(C.SharedMedia:Fetch("font", options.font), options.fontsize, options.fontflag)
	f.energybar.glowIndicatorText:SetJustifyH("CENTER")
	f.energybar.glowIndicatorText:SetJustifyV("BOTTOM")
	f.energybar.glowIndicatorText:SetShadowColor(options.shadow_color[1],options.shadow_color[2],options.shadow_color[3],options.shadow_color[4])
	f.energybar.glowIndicatorText:SetShadowOffset(options.shadow_pos[1],options.shadow_pos[2])

	for i=1, #f.icons do
		local text = f.icons[i].power1
	
		local justifyV, justifyH, pointFrom, pointTo = C:UnpackPositionString(options.icons.fonts.power.text_point) -- = "BOTTOM;CENTER",
	
		f.icons[i].power1:SetFont(C.SharedMedia:Fetch("font",  options.icons.fonts.font),  options.icons.fonts.power.fontsize,  options.icons.fonts.fontflag)
		f.icons[i].power1:SetJustifyH(justifyH)
		f.icons[i].power1:SetJustifyV(justifyV)
		f.icons[i].power1:SetShadowColor(
			options.icons.fonts.power.shadow_color[1],
			options.icons.fonts.power.shadow_color[2],
			options.icons.fonts.power.shadow_color[3],
			options.icons.fonts.power.shadow_color[4])
		f.icons[i].power1:SetShadowOffset(options.icons.fonts.shadow_pos[1],options.icons.fonts.shadow_pos[2])
		f.icons[i].power1:ClearAllPoints()
		
		if C.db.profile.icons.isvertical == 2 then -- 1 Горизонт 2 - Вертикально			
			f.icons[i].power1:SetPoint(pointFrom, f.icons[i], pointTo, options.icons.text_pos[1], options.icons.text_pos[2])
		else
			f.icons[i].power1:SetPoint(pointFrom, f.icons[i], pointTo, options.icons.text_pos[1],  options.icons.text_pos[2])
		end
		
		if options.icons.text_show_buffs then
			f.icons[i].power1:Show()
		else
			f.icons[i].power1:Hide()
		end
		
		f.icons[i].icon2:SetColorTexture(0, 0, 0, options.icons.icon_dark)
				
		local justifyV, justifyH, pointFrom, pointTo = C:UnpackPositionString(options.icons.text_point)
		
		f.icons[i].power2:ClearAllPoints()
		
		if C.db.profile.icons.isvertical == 2 then -- 1 Горизонт 2 - Вертикально	
			f.icons[i].power2:SetPoint(pointFrom, f.icons[i], pointTo, options.icons.power2_pos[1], options.icons.power2_pos[2])		
		else		
			f.icons[i].power2:SetPoint(pointFrom, f.icons[i], pointTo, options.icons.power2_pos[1],  options.icons.power2_pos[2])
		end		
		f.icons[i].power2:SetFont(C.SharedMedia:Fetch("font",  options.icons.fonts.font),  options.icons.fonts.power.fontsize,  options.icons.fonts.fontflag)
		f.icons[i].power2:SetJustifyH(justifyH)
		f.icons[i].power2:SetJustifyV(justifyV)
		f.icons[i].power2:SetShadowColor(
			options.icons.fonts.power.shadow_color[1],
			options.icons.fonts.power.shadow_color[2],
			options.icons.fonts.power.shadow_color[3],
			options.icons.fonts.power.shadow_color[4])
		f.icons[i].power2:SetShadowOffset(options.icons.fonts.shadow_pos[1],options.icons.fonts.shadow_pos[2])
	
		if options.icons.text_show_current then
			f.icons[i].power2:Show()
		else
			f.icons[i].power2:Hide()
		end
		
		local justifyV, justifyH, pointFrom, pointTo = C:UnpackPositionString(options.icons.fonts.timer.text_point) -- = "BOTTOM;CENTER",
		
		f.icons[i].timer:SetFont(C.SharedMedia:Fetch("font", options.icons.fonts.font), options.icons.fonts.timer.fontsize, options.icons.fonts.fontflag)
		f.icons[i].timer:SetJustifyH(justifyH)
		f.icons[i].timer:SetJustifyV(justifyV)
		f.icons[i].timer:SetShadowColor(
			options.icons.fonts.timer.shadow_color[1],
			options.icons.fonts.timer.shadow_color[2],
			options.icons.fonts.timer.shadow_color[3],
			options.icons.fonts.timer.shadow_color[4])
		f.icons[i].timer:SetShadowOffset(options.icons.fonts.shadow_pos[1],options.icons.fonts.shadow_pos[2])
		f.icons[i].timer:SetTextColor(
			options.icons.fonts.timer.color[1],
			options.icons.fonts.timer.color[2],
			options.icons.fonts.timer.color[3],1)
		f.icons[i].timer:SetPoint(pointFrom, f.icons[i].cooldown, pointTo, options.icons.fonts.timer.spacing_h, options.icons.fonts.timer.spacing_v)
	

	
		if options.icons.timertext then
			f.icons[i].timer:Show()
		else
			f.icons[i].timer:Hide()		
		end
		
		f.icons[i].glow:SetBackdrop({
			edgeFile = "Interface\\ChatFrame\\ChatFrameBackground",
			edgeSize = options.icons.glowsize,
		})
		f.icons[i].glow:SetBackdropBorderColor(options.icons.glowcolor[1], options.icons.glowcolor[2], options.icons.glowcolor[3], 1)
		
		if options.icons.fadingglow then
			f.icons[i].glow:SetScript("OnUpdate", updateGlow)
		else
			f.icons[i].glow:SetScript("OnUpdate", nil)
			f.icons[i].glow:SetAlpha(1)
		end
	
	end
	
	------------------------------------
	-- MANA BAR ------------------------
	------------------------------------
	backdrop 	= f.manabar.backdrop
	bg 			= f.manabar.bg
	
	f.manabar:SetStatusBarTexture(C.SharedMedia:Fetch("statusbar", options.manabar.statusbar))
	f.manabar:SetWidth(options.manabar.width)
	f.manabar:SetHeight(options.manabar.height)
--	f.manabar:SetPoint("CENTER", f, "CENTER", options.manabar.gap_h, options.manabar.gap_v)
	
	C:Mover(f.manabar, "ManaBar")
	
	backdrop:SetBackdrop({
		edgeFile = C.SharedMedia:Fetch("border", options.manabar.border.texture),
		edgeSize = options.manabar.border.size,
	})
	backdrop:SetBackdropBorderColor(options.manabar.border.color[1], options.manabar.border.color[2], options.manabar.border.color[3], options.manabar.border.color[4])
	backdrop:SetPoint("TOPLEFT", -options.manabar.border.inset, options.manabar.border.inset)
	backdrop:SetPoint("BOTTOMRIGHT", options.manabar.border.inset, -options.manabar.border.inset)
	
	f.manabar.bg2:SetTexture(C.SharedMedia:Fetch("statusbar", options.manabar.statusbar))
	f.manabar.bg2:SetVertexColor(options.manabar.border.background[1], options.manabar.border.background[2], options.manabar.border.background[3], options.manabar.border.background[4])
	
	bg:SetPoint("TOPLEFT", -options.manabar.border.bg_inset, options.manabar.border.bg_inset)
	bg:SetPoint("BOTTOMRIGHT", options.manabar.border.bg_inset, -options.manabar.border.bg_inset)
	bg:SetColorTexture(options.manabar.border.background[1], options.manabar.border.background[2], options.manabar.border.background[3], options.manabar.border.background[4])
	------------------------------------
	-- ENERGY BAR -----------------------
	------------------------------------
	
	f.energybar:SetStatusBarTexture(C.SharedMedia:Fetch("statusbar", options.energybar.statusbar))
	f.energybar:SetWidth(options.energybar.width)
	f.energybar:SetHeight(options.energybar.height)

--	f.energybar:SetPoint("CENTER", f, "CENTER", options.energybar.gap_h, options.energybar.gap_v)
	
	C:Mover(f.energybar, "EnergyBar")
	
	backdrop 	= f.energybar.backdrop
	bg 			= f.energybar.bg
	
	backdrop:SetBackdrop({
		edgeFile = C.SharedMedia:Fetch("border", options.energybar.border.texture),
		edgeSize = options.energybar.border.size,
	})
	backdrop:SetBackdropBorderColor(options.energybar.border.color[1], options.energybar.border.color[2], options.energybar.border.color[3], options.energybar.border.color[4])
	backdrop:SetPoint("TOPLEFT", -options.energybar.border.inset, options.energybar.border.inset)
	backdrop:SetPoint("BOTTOMRIGHT", options.energybar.border.inset, -options.energybar.border.inset)
	
	f.energybar.bg2:SetTexture(C.SharedMedia:Fetch("statusbar", options.energybar.statusbar))
	f.energybar.bg2:SetVertexColor(options.energybar.border.background[1], options.energybar.border.background[2], options.energybar.border.background[3], options.energybar.border.background[4])
	
	bg:SetPoint("TOPLEFT", -options.energybar.border.bg_inset, options.energybar.border.bg_inset)
	bg:SetPoint("BOTTOMRIGHT", options.energybar.border.bg_inset, -options.energybar.border.bg_inset)
	bg:SetColorTexture(options.energybar.border.background[1], options.energybar.border.background[2], options.energybar.border.background[3], options.energybar.border.background[4])
	
	f.energybar.glowIndicator:SetBackdropBorderColor(options.energybar.glowclearcast[1],options.energybar.glowclearcast[2],options.energybar.glowclearcast[3], 1)
	
	if options.energybar.show_spell_threshold then
		for i=1, #f.energybar.breakp do
			f.energybar.breakp[i]:Show()
			f.energybar.breakp[i]:Update()
		end
	else
		
		for i=1, #f.energybar.breakp do
			f.energybar.breakp[i]:Hide()
		end
	end
	
	------------------------------------
	-- COMBO POINTS --------------------
	------------------------------------
	opt	= options.combo_points
	
	C:Mover(f.cp, "CombopointBar")
	
	for i=1, 5 do
		
		local cp = f.cp[i]
		
		local width = options.combo_points.width-(options.combo_points.gap*4)

		f.cp[i]:SetWidth(width/5)
		f.cp[i]:SetHeight(options.combo_points.height)
		
		f.cp:SetSize(options.combo_points.width, options.combo_points.height)
		
		if i== 3 then
			cp:SetPoint("CENTER", f.cp, "CENTER", 0, 0)
		elseif i == 1 then
			cp:SetPoint("RIGHT", f.cp[2], "LEFT", -options.combo_points.gap, 0)
		elseif i == 2 then
			cp:SetPoint("RIGHT", f.cp[3], "LEFT", -options.combo_points.gap, 0)
		elseif i == 4 then
			cp:SetPoint("LEFT", f.cp[3], "RIGHT", options.combo_points.gap, 0)
		elseif i == 5 then
			cp:SetPoint("LEFT", f.cp[4], "RIGHT", options.combo_points.gap, 0)
		end
		
		backdrop 	= cp.backdrop
		bg 			= cp.bg
		
		cp.texture:SetTexture(C.SharedMedia:Fetch("statusbar", options.combo_points.statusbar))
		cp.texture:SetVertexColor(options.combo_points.color[i][1],options.combo_points.color[i][2],options.combo_points.color[i][3],options.combo_points.color[i][4])

		
		backdrop:SetBackdrop({
			edgeFile = C.SharedMedia:Fetch("border", options.combo_points.border.texture),
			edgeSize = options.combo_points.border.size,
		})
		backdrop:SetBackdropBorderColor(options.combo_points.border.color[1], options.combo_points.border.color[2], options.combo_points.border.color[3], options.combo_points.border.color[4])
		backdrop:SetPoint("TOPLEFT", -options.combo_points.border.inset, options.combo_points.border.inset)
		backdrop:SetPoint("BOTTOMRIGHT", options.combo_points.border.inset, -options.combo_points.border.inset)
		
		cp.bg2:SetTexture(C.SharedMedia:Fetch("statusbar", options.combo_points.statusbar))
		cp.bg2:SetVertexColor(options.combo_points.border.background[1], options.combo_points.border.background[2], options.combo_points.border.background[3], options.combo_points.border.background[4])
	
		bg:SetPoint("TOPLEFT", -options.combo_points.border.bg_inset, options.combo_points.border.bg_inset)
		bg:SetPoint("BOTTOMRIGHT", options.combo_points.border.bg_inset, -options.combo_points.border.bg_inset)
		bg:SetColorTexture(options.combo_points.border.background[1], options.combo_points.border.background[2], options.combo_points.border.background[3], options.combo_points.border.background[4])
	
	end
	
	opt	= options.icons
	
	local partial_1 = #order_spell%2  -- если 0 то середина между иконками 1 то середина иконки
	local numIconStep = floor(#order_spell*0.5)
	
	if C.db.profile.icons.isvertical == 2 then -- 1 Горизонт 2 - Вертикально	
		f.icons:SetSize(1, options.icons.width)
		C:Mover(f.icons, "IconsBar",  min(30, options.icons.max_width), options.icons.width)
	else
		f.icons:SetSize(options.icons.width, 1)
		C:Mover(f.icons, "IconsBar", options.icons.width, min(30, options.icons.max_width))
	end

	local numicons = #order_spell
	if options.icons.ignore_mmonfire and show_moonfire_icon then
		numicons = numicons - 1
	end
	if options.icons.ignore_savageroar and show_savage_roar_icon then
		numicons = numicons - 1
	end
		
	local iconGap = options.icons.gap
	
	local width = options.icons.width-(options.icons.gap*(numicons-1))
	
	local swidth = width/numicons
	
	if swidth > options.icons.max_width then
		swidth = options.icons.max_width 
	end
	
	local iconOffset = 0
	
	if partial_1 == 1 then
		-- Середина иконки			
		iconOffset = ( numIconStep * ( swidth + iconGap ) ) --+  ( swidth * 0.5 )
	else
		-- Середина отступа				
		iconOffset = ( numIconStep * swidth ) + (( numIconStep - 1 ) * iconGap) + ( iconGap * 0.5 ) - ( swidth * 0.5 )
	end
		
	
--	print('T', #order_spell, numicons, partial_frame, numIconStep)
--	print('T2', 'Step', numIconStep*swidth + swidth * iconGap)
	
	for i, spellid in pairs(order_spell) do
		f.icons[i] = f.icons[i] or C:AddIcon(spellid, f)
		
		f.icons[i]:SetWidth(swidth)
		f.icons[i]:SetHeight(swidth)
		f.icons[i]:ClearAllPoints()
		
		if C.db.profile.icons.isvertical == 2 then -- 1 Горизонт 2 - Вертикально			
			if i == 1 then
				if options.icons.anchoring == 1 then
					f.icons[i]:SetPoint("LEFT", f.icons, "LEFT", 0, iconOffset)
				else
					f.icons[i]:SetPoint("RIGHT", f.icons, "RIGHT", 0, iconOffset)
				end
			else
				f.icons[i]:SetPoint("TOP", f.icons[i-1], "BOTTOM", 0, -options.icons.gap)
			end		
		else		
			if i == 1 then
				if options.icons.anchoring == 1 then
					f.icons[i]:SetPoint("BOTTOM", f.icons, "BOTTOM", -iconOffset, 0)
				else
					f.icons[i]:SetPoint("TOP", f.icons, "TOP", -iconOffset, 0)
				end
			else
				f.icons[i]:SetPoint("LEFT", f.icons[i-1], "RIGHT", options.icons.gap, 0)
			end
		end
		
		--[==[
		if not f.icons[i] then
			f.icons[i] = C:AddIcon(spellid, f)
		end
		
		
		local numicons = ( options.icons.ignore_mmonfire and show_moonfire_icon ) and #order_spell - 1 or #order_spell
		
		local width = options.icons.width-(options.icons.gap*(numicons-1))
	
		local swidth = width/numicons
		
		if swidth > options.icons.max_width then
			swidth = options.icons.max_width 
		end
		
		f.icons[i]:SetWidth(swidth)
		f.icons[i]:SetHeight(swidth)
		f.icons[i]:ClearAllPoints()
		
		if partial_1 == 1 then
			if partial_frame == i then
		
				if options.icons.anchoring == 1 then
					f.icons[i]:SetPoint("BOTTOM", f.icons, "BOTTOM", 0, 0)
				else
					f.icons[i]:SetPoint("TOP", f.icons, "TOP", 0, 0)
				end
				
			elseif i < partial_frame then
			
				print('T', i, i+1, partial_frame)
				
				f.icons[i]:SetPoint("RIGHT", f.icons[i+1], "LEFT", -options.icons.gap, 0)
			elseif i > partial_frame then
				f.icons[i]:SetPoint("LEFT", f.icons[i-1], "RIGHT", options.icons.gap, 0)
			end
		else
			if i == partial_frame_1 then
			
				if options.icons.anchoring == 1 then
					f.icons[i]:SetPoint("BOTTOMRIGHT", f.icons, "BOTTOM", -options.icons.gap*0.5, 0)
				else
					f.icons[i]:SetPoint("TOPRIGHT", f.icons, "TOP", -options.icons.gap*0.5, 0)
				end
				
			--	f.icons[i]:SetPoint("RIGHT", f.icons, "CENTER", -options.icons.gap*0.5 , 0)
			elseif i == partial_frame_1+1 then
			
				if options.icons.anchoring == 1 then
					f.icons[i]:SetPoint("BOTTOMLEFT", f.icons, "BOTTOM", options.icons.gap*0.5, 0)
				else
					f.icons[i]:SetPoint("TOPLEFT", f.icons, "TOP", options.icons.gap*0.5, 0)
				end
				
			--	f.icons[i]:SetPoint("LEFT", f.icons, "CENTER", options.icons.gap*0.5 , 0)
			elseif i < partial_frame_1 then
				f.icons[i]:SetPoint("RIGHT", f.icons[i+1], "LEFT", -options.icons.gap, 0)
			elseif i > partial_frame_1+1 then
				f.icons[i]:SetPoint("LEFT", f.icons[i-1], "RIGHT", options.icons.gap, 0)
			end	
		end
		]==]
		
		backdrop 	= f.icons[i].backdrop
		bg 			= f.icons[i].bg
		
		backdrop:SetBackdrop({
			edgeFile = C.SharedMedia:Fetch("border", options.icons.border.texture),
			edgeSize = options.icons.border.size,
		})
		backdrop:SetBackdropBorderColor(options.icons.border.color[1], options.icons.border.color[2], options.icons.border.color[3], options.icons.border.color[4])
		backdrop:SetPoint("TOPLEFT", -options.icons.border.inset, options.icons.border.inset)
		backdrop:SetPoint("BOTTOMRIGHT", options.icons.border.inset, -options.icons.border.inset)
		
		bg:SetPoint("TOPLEFT", -options.icons.border.bg_inset, options.icons.border.bg_inset)
		bg:SetPoint("BOTTOMRIGHT", options.icons.border.bg_inset, -options.icons.border.bg_inset)
		bg:SetColorTexture(options.icons.border.background[1], options.icons.border.background[2], options.icons.border.background[3], options.icons.border.background[4])
	
		backdrop 	= f.icons[i].statusbar.backdrop
		bg 			= f.icons[i].statusbar.bg
		
		backdrop:SetBackdrop({
			edgeFile = C.SharedMedia:Fetch("border", options.icons.border_tick.texture),
			edgeSize = options.icons.border_tick.size,
		})
		backdrop:SetBackdropBorderColor(options.icons.border_tick.color[1], options.icons.border_tick.color[2], options.icons.border_tick.color[3], options.icons.border_tick.color[4])
		backdrop:SetPoint("TOPLEFT", -options.icons.border_tick.inset, options.icons.border_tick.inset)
		backdrop:SetPoint("BOTTOMRIGHT", options.icons.border_tick.inset, -options.icons.border_tick.inset)
		
		bg:SetPoint("TOPLEFT", -options.icons.border_tick.bg_inset, options.icons.border_tick.bg_inset)
		bg:SetPoint("BOTTOMRIGHT", options.icons.border_tick.bg_inset, -options.icons.border_tick.bg_inset)
		bg:SetColorTexture(options.icons.border_tick.background[1], options.icons.border_tick.background[2], options.icons.border_tick.background[3], options.icons.border_tick.background[4])
		
		f.icons[i].statusbar:ClearAllPoints()

		if ( C.db.profile.icons.tick_position == 'LEFT' or C.db.profile.icons.tick_position == 'RIGHT' ) then -- 1 Горизонт 2 - Вертикально		
			f.icons[i].statusbar:SetWidth(options.icons.height_t)
			f.icons[i].statusbar:SetHeight(f.icons[i]:GetWidth()) --options.icons.width)
			f.icons[i].statusbar:SetOrientation('VERTICAL')
			
			if C.db.profile.icons.tick_position == 'LEFT' then
				f.icons[i].statusbar:SetPoint("RIGHT", f.icons[i], "LEFT", options.icons.gap_v, 0)
			else
				f.icons[i].statusbar:SetPoint("LEFT", f.icons[i], "RIGHT", options.icons.gap_v, 0)
			end
		else
			f.icons[i].statusbar:SetWidth(f.icons[i]:GetWidth())
			f.icons[i].statusbar:SetHeight(options.icons.height_t)
			f.icons[i].statusbar:SetOrientation('HORIZONTAL')
		
			if C.db.profile.icons.tick_position == 'TOP' then
				f.icons[i].statusbar:SetPoint("BOTTOM", f.icons[i], "TOP", 0, options.icons.gap_v)
			else
				f.icons[i].statusbar:SetPoint("TOP", f.icons[i], "BOTTOM", 0, options.icons.gap_v)
			end
		end
		
		
		f.icons[i].statusbar:SetStatusBarTexture(C.SharedMedia:Fetch("statusbar", options.icons.statusbar))
		f.icons[i].statusbar:SetStatusBarColor(options.icons.color_tick[1],options.icons.color_tick[2],options.icons.color_tick[3], options.icons.color_tick[4])
		
		if not options.icons.hide_overlay then		
			f.icons[i].cooldown:SetSwipeColor(0, 0, 0, 0)
			f.icons[i].cooldown:SetDrawEdge(false)
		else
			f.icons[i].cooldown:SetSwipeColor(0, 0, 0, 0.6)
			f.icons[i].cooldown:SetDrawEdge(false)
		end

		f.icons[i].cooldown:SetHideCountdownNumbers(options.icons.timertext)		
	end
	
	
	-------------------------------
	-- ORDERING -------------------
	-------------------------------
		
	local prev = f
	
	if options.combo_points.show then
		for i=1, 5 do
			f.cp[i]:Show()
		end
	else
		for i=1, 5 do
			f.cp[i]:Hide()
		end	
	end
	
	if options.energybar.show then
		f.energybar:Show()		
	else
		f.energybar:Hide()
	end
	
	if options.manabar.show then
	--	f.manabar:Show()
	else
		f.manabar:Hide()
	end

	if options.show_ticks then
		for i, spellid in pairs(order_spell) do
			f.icons[i].statusbar:Show()
		end
	else	
		for i, spellid in pairs(order_spell) do
			f.icons[i].statusbar:Hide()
		end
	end
	
	if options.energybar.show_text then
		f.energybar.text:Show()
	else
		f.energybar.text:Hide()
	end
		
	if options.manabar.show_text then
		f.manabar.text:Show()
	else
		f.manabar.text:Hide()
	end
	--[[
	if options.energybar.show_spark then
		f.energybar.spark:Show()
	else
		f.energybar.spark:Hide()
	end
	]]
	if C.disable_addon then
		C.movingFrame:Hide()
		C:ToggleCooldownBar("Hide")
		return
	end
	
	C:UpdateMainFrameVisability()
	
	C:MultitargetFontUpdate()
	
	C:UNIT_POWER_FREQUENT(_, 'player')
	self:UpdateVisible("target")
end

function C:UNIT_POWER_FREQUENT(event, unit)
	if unit ~= "player" then return end
	
	local manabar   = self.movingFrame.manabar
	local energybar = self.movingFrame.energybar
	local movingFrame = self.movingFrame
	
	local form = GetForm()
	
	if form == CAT_FORM and options.energybar.show_spell_threshold then
		for i=1, #self.movingFrame.energybar.breakp do
			self.movingFrame.energybar.breakp[i]:Show()
		end
	else
		for i=1, #self.movingFrame.energybar.breakp do
			self.movingFrame.energybar.breakp[i]:Hide()
		end
	end
	
	local mana = UnitPower("player", 0)
	local maxmana = UnitPowerMax("player", 0)
	
	local energy = UnitPower("player", 3)
	local energyMax = UnitPowerMax('player', 3)
	
	local rage = UnitPower("player", 1)
	
	local combopoints = UnitPower("player", 4)
	
	if combopoints > 0 then
		cp_bycast = combopoints
	end
	
	if mana ~= maxmana and form ~= 0 then
		manabar:SetMinMaxValues(0, maxmana)
		manabar:SetValue(mana)
		manabar.text:SetText(mana)
		if options.manabar.show then
			manabar:Show()
		end
	else
		manabar:Hide()
	end
	
	for i=1, combopoints do
		movingFrame.cp[i].texture:Show()
	end
	for i=combopoints+1, 5 do
		movingFrame.cp[i].texture:Hide()
	end

	if form == CAT_FORM then
	
		if CLEAR_CAST_FIND and options.energybar.clearcastbar then
			energybar:SetStatusBarColor(options.energybar.glowclearcast[1],options.energybar.glowclearcast[2],options.energybar.glowclearcast[3], 1)
		else
			energybar:SetStatusBarColor(options.energybar.color.energy[1],  options.energybar.color.energy[2], options.energybar.color.energy[3], 1)
		end
		
		energybar:SetMinMaxValues(0, energyMax)
		energybar:SetValue(energy)
		energybar.text:SetText(energy)
		if options.energybar.show then
			energybar:Show()
		end
		
		if options.energybar.show_spark then
			if energy < energyMax then
				energybar.spark:Show()
			else
				energybar.spark:Hide()
			end
		end
	
		if options.energybar.show_spell_threshold then
			for i=1, #self.movingFrame.energybar.breakp do
				energybar.breakp[i]:Update()
			end
		end
	elseif form == BEAR_FORM then
		energybar:SetStatusBarColor(options.energybar.color.rage[1],  options.energybar.color.rage[2], options.energybar.color.rage[3], 1)
		energybar:SetMinMaxValues(0, energyMax)
		energybar:SetValue(rage)
		energybar.text:SetText(rage)
		if options.energybar.show then
			energybar:Show()
		end
		
		if options.energybar.show_spark then
			if energy < energyMax then
				energybar.spark:Show()
			else
				energybar.spark:Hide()
			end
		end
		
	elseif form == 0 then

		energybar:SetStatusBarColor(options.manabar.color[1], options.manabar.color[2],options.manabar.color[3], 1)
		energybar:SetMinMaxValues(0, maxmana)
		energybar:SetValue(mana)
		energybar.text:SetText(mana)
		if options.energybar.show then
			energybar:Show()
		end
		
		if options.energybar.show_spark then
			if mana < maxmana then
				energybar.spark:Show()
			else
				energybar.spark:Hide()
			end
		end
		
		manabar:Hide()
	else
		energybar:Hide()
	end
end

function C:UPDATE_SHAPESHIFT_FORM()
	
--	local form = GetForm(true)
	
	self.myGUID = UnitGUID("player")
--	print('UPDATE_SHAPESHIFT_FORM', self.myGUID)
	
	self:UNIT_POWER_FREQUENT(event, "player")
	
	C:UpdateMainFrameVisability()
end

function C:PLAYER_ENTERING_WORLD()
	self:UPDATE_SHAPESHIFT_FORM()
end

function C:PLAYER_REGEN_ENABLED()
	local alpha = options.icons.alpha_outof_combat or 0.8
	
	if C.disable_addon then
		C.movingFrame:Hide()
		C:ToggleCooldownBar("Hide")
		return
	end
	
	if not UnitAffectingCombat("player") then	
		for i=1, #C.movingFrame.icons do	
			C.movingFrame.icons[i]:SetAlpha(alpha)	
		end
	end
	
	C:UpdateMainFrameVisability()
end
C.PLAYER_REGEN_DISABLED = C.PLAYER_REGEN_ENABLED

local function ShowHideUI()
	if AleaUI_GUI:IsOpened(AddOn) then
		AleaUI_GUI:Close(AddOn)
	else
		AleaUI_GUI:Open(AddOn)
	end
end

C:RegisterEvent("PLAYER_LOGIN")

function C:PLAYER_LOGIN()
	
	self.myClass = select(2, UnitClass("player"))
	self.myGUID = UnitGUID("player")
	
	C:DefaultOptions()
	self.GUI = C:OptionsTable()
	
	options = C.db.profile
--	GetForm(true) -- 0 - human ; 1 - bear; 2 - cat
	

	self:InitFrames()
	self:UnlockFrames()

	AleaUI_GUI:RegisterMainFrame(AddOn, C.GUI)
	AleaUI_GUI.SlashCommand(AddOn, "/fdd", ShowHideUI)
	AleaUI_GUI.MinimapButton(AddOn, { OnClick = ShowHideUI, texture = "Interface\\Icons\\ability_druid_catform" }, options.minimap)
	
	self:UpdateMultiDotBorders()
	self:MultitargetFontUpdate()
	self:UpdateCooldownOrders()
	
	self:UpdateAuraWidgets()

	self:InitSwitchTalents()
	self:UNIT_POWER_FREQUENT(_, "player")
	
	self:PLAYER_REGEN_ENABLED()
	self:UPDATE_SHAPESHIFT_FORM()
	self:UpdateBuffCheckStatus()
	self:UpdateBuffCheckOverlay()
	
	ALEAUI_OnProfileEvent("FeralDotDamageDB","PROFILE_CHANGED", function()	
		C:OnProfileChange()
	end)
	ALEAUI_OnProfileEvent("FeralDotDamageDB","PROFILE_RESET", function()	
		C:OnProfileChange()
	end)
end

function C:OnProfileChange()
	
	self:DefaultOptions()
	self.GUI = self:OptionsTable()
	
	options = self.db.profile
	
	self:UnlockFrames()
	
	AleaUI_GUI:RegisterMainFrame(AddOn, self.GUI)

--	self:UpdateFramesStyle()

	self:UpdateMultiDotBorders()
	self:MultitargetFontUpdate()
	self:UpdateCooldownOrders()
	
	self:UpdateAuraWidgets()
	
	self:InitSwitchTalents()
	self:UNIT_POWER_FREQUENT(_, "player")
	
	self:PLAYER_REGEN_ENABLED()
	self:UPDATE_SHAPESHIFT_FORM()
	self:UpdateBuffCheckStatus()
	self:UpdateBuffCheckOverlay()
end

do
	local IsSpellKnown = IsSpellKnown
	local GetTalentInfo = GetTalentInfo
	local MAX_TALENT_TIERS = MAX_TALENT_TIERS
	
	local feraldd_spec = 103

	local function IsTalentKnown(spellID)
		for i=1, MAX_TALENT_TIERS do
			for a=1, 3 do
				local talentID, name, texture, selected, availible, spellID_talent = GetTalentInfo(i, a, GetActiveSpecGroup())

				if selected then
					if spellID == spellID_talent then
						return true
					end
				end
			end
		end
		
		return false
	end

	C.IsTalentKnown = IsTalentKnown

	function C:UpdateTalentsAndPercs(event)	
	
		imprived_rake_gained = true --IsSpellKnown(157276)
		moonfire_talent 	 = IsTalentKnown(155580)-- IsSpellKnown(155580)
		savage_roar_talent 	 = IsTalentKnown(52610)
	--	print('T', 'savage_roar_talent', savage_roar_talent)
	--	print('T', self, event, moonfire_talent, IsTalentKnown(155580))
	--	print('T', IsSpellKnown(52610))
	--	print('T', IsTalentKnown(155672))
	
		if IsTalentKnown(202032) then
			dots_info[glybokayrana_spid] 	= { 3*0.65, 15*0.65, 19.5*0.65 , 	glybokayrana_name,	4.5*0.65} -- tick period, default duration, pandemia duration
			dots_info[razorvat_spid] 		= { 2*0.65, 24*0.65, 31*0.65   , 	razorvat_name,		7.2*0.65}
			dots_info[vzbuchka_spid] 		= { 3*0.65, 15*0.65, 19.5*0.65 , 	vzbuchka_name,		4.5*0.65}
		else		
			dots_info[glybokayrana_spid] 	= { 3, 15, 19.5 , 	glybokayrana_name,	4.5} -- tick period, default duration, pandemia duration
			dots_info[razorvat_spid] 		= { 2, 24, 31   , 	razorvat_name,		7.2}
			dots_info[vzbuchka_spid] 		= { 3, 15, 19.5 , 	vzbuchka_name,		4.5}
		end
		
		C:UpdateOrders()
		C:UpdateCooldownOrders()
		C:UpdateBuffCheckStatus()
		C:UpdateBuffCheckOverlay()
		
		local currentSpec = GetSpecialization()
		local currentSpecID = currentSpec and GetSpecializationInfo(currentSpec)
		
		
			
		local isCatImpForm = C.db.profile.show_for_non_feral_spec and ( feraldd_spec ~= currentSpecID ) and ( IsTalentKnown(197490) or IsTalentKnown(202157) or IsTalentKnown(202155) ) or false

		if isCatImpForm then
			C.disable_addon = false
			C.partial_disable_addon = true
			C.only_in_cantForm = true
			
			C:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
			C:RegisterEvent("UNIT_POWER_FREQUENT")
			C:RegisterEvent("PLAYER_FOCUS_CHANGED")
			C:RegisterEvent("PLAYER_TARGET_CHANGED")
			C:RegisterEvent("PLAYER_REGEN_ENABLED")
			C:RegisterEvent("PLAYER_REGEN_DISABLED")
			C:RegisterEvent("UNIT_AURA")
			C:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			C:RegisterEvent('PLAYER_ENTERING_WORLD')
		
		elseif feraldd_spec ~= currentSpecID then
			C.disable_addon = true
			C.only_in_cantForm = false
			C.partial_disable_addon = false
			
			C:UnregisterEvent("UPDATE_SHAPESHIFT_FORM")
			C:UnregisterEvent("UNIT_POWER_FREQUENT")
			C:UnregisterEvent("PLAYER_FOCUS_CHANGED")
			C:UnregisterEvent("PLAYER_TARGET_CHANGED")
			C:UnregisterEvent("PLAYER_REGEN_ENABLED")
			C:UnregisterEvent("PLAYER_REGEN_DISABLED")
			C:UnregisterEvent("UNIT_AURA")
			C:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			C:UnregisterEvent('PLAYER_ENTERING_WORLD')
		else
			C.disable_addon = false
			C.only_in_cantForm = false
			C.partial_disable_addon = false
			
			C:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
			C:RegisterEvent("UNIT_POWER_FREQUENT")
			C:RegisterEvent("PLAYER_FOCUS_CHANGED")
			C:RegisterEvent("PLAYER_TARGET_CHANGED")
			C:RegisterEvent("PLAYER_REGEN_ENABLED")
			C:RegisterEvent("PLAYER_REGEN_DISABLED")
			C:RegisterEvent("UNIT_AURA")
			C:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			C:RegisterEvent('PLAYER_ENTERING_WORLD')
		end
		
		C:PLAYER_REGEN_ENABLED()
		C:UpdateFramesStyle()
	end

	local eventframe = CreateFrame("Frame")
	eventframe:SetScript("OnEvent", function(self, event, unit)
		if event == 'INSPECT_READY' then
			if unit == UnitGUID('player') then
				C.UpdateTalentsAndPercs(self, event)
			end
		else
			C_Timer.After(0.1, function() C.UpdateTalentsAndPercs(self, event) end)
		end
	end)
	
	
	function C:InitSwitchTalents()
		eventframe:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
		eventframe:RegisterEvent("PLAYER_TALENT_UPDATE")
		eventframe:RegisterEvent("PLAYER_LEVEL_UP")
		eventframe:RegisterEvent("PLAYER_LOGIN")
		eventframe:RegisterEvent("INSPECT_READY")
		
		C_Timer.After(0.1, function() self:UpdateTalentsAndPercs()  end)
	end
	
	
end

do

	local table_concat = table.concat
	
	local lastTimeCheck = 0
	local header = '|cFFFFFF00'..AddOn..' '..L['Проверка баффов']..':|r'
	
	local buffList = {
		['110'] = {
			flask = 188033,
			food = 188534,
			rune = 224001,
			runeItem = 0,
		},
		['100'] = {
			flask = 156064,
			food = 188534,
			rune = 175456,
			runeItem = 118630,		
		},
	
	}

	local function GetBuff(typo)			
		local dir = ( UnitLevel('player') == 110 ) and '110' or '100'
		
		return ( GetSpellInfo(buffList[dir][typo]) )
	end
	
	local function GetBuffLink(typo)
		local dir = ( UnitLevel('player') == 110 ) and '110' or '100'
		
		local link
		
		if typo == 'rune' then
			local name, linkItem = GetItemInfo(buffList[dir]['runeItem'])
			
			link = linkItem or GetSpellLink(buffList[dir][typo])
		else
			link = GetSpellLink(buffList[dir][typo])
		end
		
		return link
	end
	
	local function GetBuffTexture(typo)
		local dir = ( UnitLevel('player') == 110 ) and '110' or '100'
		
		return ( GetSpellTexture(buffList[dir][typo]) )
	end
	
	local function GetAuraIcon()
	
		local f = CreateFrame('Frame')
		f:SetSize(26, 26)
		f.icon = f:CreateTexture()
		f.icon:SetDrawLayer('ARTWORK', 1)
		f.icon:SetAllPoints()
		f.icon:SetTexture(GetSpellTexture(aginFlask_id))
		f.icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)	
		
		f.cooldown = CreateFrame('Cooldown', nil, f, "CooldownFrameTemplate")
		f.cooldown:SetAllPoints()
		f.cooldown:SetDrawEdge(true)
		f.cooldown:SetSwipeColor(0, 0, 0, 0.6)	
		f.cooldown:SetBlingTexture("")	
		
		f.text = f:CreateFontString()
		f.text:SetFont(STANDARD_TEXT_FONT, 14, 'OUTLINE')
		f.text:SetPoint('LEFT', f, 'RIGHT', 2, 0)
		f.text:SetTextColor(1, 1, 1)
		f.text:Hide()
		
		return f
	end
	
	local buffFrame = CreateFrame('Frame', nil, UIParent)
	buffFrame:SetSize(110, 133)
	buffFrame:SetPoint('LEFT', UIParent, 'LEFT', 300, 0)
	
	buffFrame:Hide()
	--[[
	buffFrame.bg = buffFrame:CreateTexture()
	buffFrame.bg:SetAllPoints()
	buffFrame.bg:SetTexture(0, 0, 0, 0.5)
	]]
	buffFrame.flask = GetAuraIcon()
	buffFrame.flask:SetParent(buffFrame)
	buffFrame.flask.icon:SetTexture(GetBuffTexture('flask'))
	
	buffFrame.rune = GetAuraIcon()
	buffFrame.rune:SetParent(buffFrame)
	buffFrame.rune.icon:SetTexture(GetBuffTexture('rune'))
	
	buffFrame.food = GetAuraIcon()
	buffFrame.food:SetParent(buffFrame)
	buffFrame.food.icon:SetTexture(GetBuffTexture('food'))

	local setDesaturated = false
	
	
	buffFrame.Handler = function(self, event)
		
		if not IsInRaid() and not IsInGroup() then 
			self:Hide()
		--	return 
		end
		if not InCombatLockdown() then 
		--	self:Hide()
		--	return 
		end
		
		local show = false
		
		if C.disable_addon then return end
		if C.partial_disable_addon then return end
		
		local name, rank, icon, count, dispelType, duration, expires = UnitBuff('player', GetBuff('flask'))			
		if name and options.others.flashCheck then
			self.flask.cooldown:SetCooldown(expires-duration, duration)
			self.flask.icon:SetDesaturated(false)
			if expires - GetTime() < 60*10 then

				self.flask:Show() 
				FeralDotDamage.ShowOverlayGlow(self.flask)	

				if show == false then show = true end
			else
				self.flask:Hide() 
				FeralDotDamage.HideOverlayGlow(self.flask)
			end
		else
			self.flask:Show() 
			FeralDotDamage.ShowOverlayGlow(self.flask)

			self.flask.icon:SetDesaturated(setDesaturated)
			self.flask.cooldown:SetCooldown(0, 0)
			self.flask.cooldown:Clear()
			if show == false then show = true end
		end
		
		self.flask.icon:SetTexture(GetBuffTexture('flask'))
		
		local name, rank, icon, count, dispelType, duration, expires = UnitBuff('player', GetBuff('rune'))			
		if name and options.others.runeCheck then
			self.rune.cooldown:SetCooldown(expires-duration, duration)
			self.rune.icon:SetDesaturated(false)
			if expires - GetTime() < 60*10 then
				self.rune:Show() 
				FeralDotDamage.ShowOverlayGlow(self.rune)

				if show == false then show = true end
			else
				self.rune:Hide()
				FeralDotDamage.HideOverlayGlow(self.rune)
			end
		else
			self.rune.icon:SetDesaturated(setDesaturated)
			self.rune.cooldown:SetCooldown(0, 0)
			self.rune.cooldown:Clear()
			self.rune:Show() 
			FeralDotDamage.ShowOverlayGlow(self.rune)
			
			if show == false then show = true end
		end

		self.rune.icon:SetTexture(GetBuffTexture('rune'))
		
		local name, rank, icon, count, dispelType, duration, expires = UnitBuff('player', GetBuff('food'))			
		if name and options.others.foodCheck then
			self.food.cooldown:SetCooldown(expires-duration, duration)
			self.food.icon:SetDesaturated(false)
			if expires - GetTime() < 60*10 then

				self.food:Show()
				FeralDotDamage.ShowOverlayGlow(self.food)
				
				
				if show == false then show = true end
			else
				FeralDotDamage.HideOverlayGlow(self.food)
				self.food:Hide()
			end
		else
			self.food.icon:SetDesaturated(setDesaturated)
			self.food.cooldown:SetCooldown(0, 0)
			self.food.cooldown:Clear()
			self.food:Show()
			FeralDotDamage.ShowOverlayGlow(self.food)
			
			if show == false then show = true end
		end
		
		self.food.icon:SetTexture(GetBuffTexture('food'))
		
		if show then
			self:Show()
		else
			self:Hide()
		end
		
	end
	
	buffFrame:SetScript('OnEvent', buffFrame.Handler)
	
	
	local function CheckBuffs()
		local msg1 = nil
		local msg2 = nil
		local msg3 = nil

		if C.disable_addon then return end
		if C.partial_disable_addon then return end
		
		if options.others.flashCheck then
			
			local name, rank, icon, count, dispelType, duration, expires = UnitBuff('player', GetBuff('flask'))
			
			if name then
				if expires - GetTime() < 60*10 then
					msg1 = L['Скоро закончится!']
				end
			else			
				msg1 = L['Отутствует']
			end
			
		end
		
		if options.others.runeCheck then
			
			local name, rank, icon, count, dispelType, duration, expires = UnitBuff('player', GetBuff('rune'))
			
			if name then
				if expires - GetTime() < 60*10 then
					msg2 = L['Скоро закончится!']
				end
			else			
				msg2 = L['Отутствует']
			end
			
		end
		
		if options.others.foodCheck then
			
			local name, rank, icon, count, dispelType, duration, expires = UnitBuff('player', GetBuff('food'))
			
			if name then
				if expires - GetTime() < 60*10 then
					msg3 = L['Скоро закончится!']
				end
			else			
				msg3 = L['Отутствует']
			end
			
		end

		if msg1 or msg2 or msg3 or ( msg4 and msg4:len() > 0 ) then
			DEFAULT_CHAT_FRAME:AddMessage('------------')
			DEFAULT_CHAT_FRAME:AddMessage(header)
			
			if  ( GetTime() > lastTimeCheck ) then
				lastTimeCheck = GetTime() + 20		
				local willplay, handler = PlaySoundFile(C.SharedMedia:Fetch("sound", C.db.profile.others.checkBuffsSoundFile), "MASTER")	
			end
		
		end
	
		if msg1 then			
			DEFAULT_CHAT_FRAME:AddMessage('|cFFFFFF00'..GetBuffLink('flask')..'|r|cFFFF0000: '..msg1)
		end
		if msg2 then	
			DEFAULT_CHAT_FRAME:AddMessage('|cFFFFFF00'.. GetBuffLink('rune')..'|r|cFFFF0000: '..msg2)
		end
		if msg3 then
			DEFAULT_CHAT_FRAME:AddMessage('|cFFFFFF00'..L['Еда']..'|r|cFFFF0000: '..msg3)
		end

		if msg1 or msg2 or msg3 then		
			DEFAULT_CHAT_FRAME:AddMessage('------------')
		end
	end
	
	local eventframe = CreateFrame("Frame")
	eventframe:SetScript("OnEvent", CheckBuffs)
	
	
	function C:UpdateBuffCheckOverlay()
		
			
		C:Mover(buffFrame, "BuffCheckFrames")
		
		local icon2size = options.others.overlay_minorIconSize or 18
		local iconsize = options.others.overlay_mainIconSize or 26
		
	--	print('T', 'UpdateBuffCheckOverlay')
		
		if options.others.horizontal_overlay then
			
			buffFrame:SetSize(110, 133)
			
			buffFrame.flask:ClearAllPoints()
			buffFrame.flask:SetSize(iconsize, iconsize)
			buffFrame.flask:SetPoint('TOP', buffFrame, 'TOP', 0, 0)
			if buffFrame.flask:IsShown() then
				FeralDotDamage.ShowOverlayGlow(buffFrame.flask)
			else
				FeralDotDamage.HideOverlayGlow(buffFrame.flask)
			end
			buffFrame.rune:ClearAllPoints()
			buffFrame.rune:SetSize(iconsize, iconsize)
			buffFrame.rune:SetPoint('LEFT', buffFrame.flask, 'RIGHT', 5, 0)
			if buffFrame.rune:IsShown() then
				FeralDotDamage.ShowOverlayGlow(buffFrame.rune)
			else
				FeralDotDamage.HideOverlayGlow(buffFrame.rune)
			end
			
			buffFrame.food:ClearAllPoints()
			buffFrame.food:SetSize(iconsize, iconsize)
			buffFrame.food:SetPoint('RIGHT', buffFrame.flask, 'LEFT', -5, 0)
			if buffFrame.food:IsShown() then
				FeralDotDamage.ShowOverlayGlow(buffFrame.food)
			else
				FeralDotDamage.HideOverlayGlow(buffFrame.food)
			end
			
		else
		
			buffFrame:SetSize(110, 133)
			
			buffFrame.flask:ClearAllPoints()
			buffFrame.flask:SetSize(iconsize, iconsize)
			buffFrame.flask:SetPoint('LEFT', buffFrame, 'LEFT', 0, 0)		
			if buffFrame.flask:IsShown() then
				FeralDotDamage.ShowOverlayGlow(buffFrame.flask)
			else
				FeralDotDamage.HideOverlayGlow(buffFrame.flask)
			end
			
			buffFrame.rune:ClearAllPoints()
			buffFrame.rune:SetSize(iconsize, iconsize)
			buffFrame.rune:SetPoint('TOP', buffFrame.flask, 'BOTTOM', 0, -5)
			if buffFrame.rune:IsShown() then
				FeralDotDamage.ShowOverlayGlow(buffFrame.rune)
			else
				FeralDotDamage.HideOverlayGlow(buffFrame.rune)
			end
			
			buffFrame.food:ClearAllPoints()
			buffFrame.food:SetSize(iconsize, iconsize)
			buffFrame.food:SetPoint('BOTTOM', buffFrame.flask, 'TOP', 0, 5)
			if buffFrame.food:IsShown() then
				FeralDotDamage.ShowOverlayGlow(buffFrame.food)
			else
				FeralDotDamage.HideOverlayGlow(buffFrame.food)
			end

		end
		
		if options.others.overlay then
			buffFrame:RegisterUnitEvent('UNIT_AURA', 'player')
		
			local events = options.others.checkOnEvent or 5
		
			if events == 5 or events == 3 then	
				buffFrame:RegisterEvent('ENCOUNTER_START')
			end
			if events == 1 or events == 4 or events == 5 then
				buffFrame:RegisterEvent('READY_CHECK')
			end
			if events == 2 or events == 4 then
				buffFrame:RegisterEvent('PLAYER_REGEN_DISABLED')
			end
			
		else
			buffFrame:UnregisterAllEvents()
			buffFrame:Hide()
		end
	end
	
	
	function C:UpdateBuffCheckStatus()
		eventframe:UnregisterAllEvents()

		if(not options.others.flashCheck and 
		   not options.others.runeCheck and
		   not options.others.foodCheck ) or not options.others.buffCheck then
		   
		   return
		end
		   
		local events = options.others.checkOnEvent or 5
		
		if events == 5 or events == 3 then	
			eventframe:RegisterEvent('ENCOUNTER_START')
		end
		if events == 1 or events == 4 or events == 5 then
			eventframe:RegisterEvent('READY_CHECK')
		end
		if events == 2 or events == 4 then
			eventframe:RegisterEvent('PLAYER_REGEN_DISABLED')
		end
		
		
	end
end

do

	local movers = {}
	
	local buttons_name = { "◄", "▲", "▼", "►" }
	local buttons_move = { { -1, 0 } , { 0, 1 }, { 0, -1} , { 1, 0} }

	local function round(num)
		return floor(num+0.5)
	end
	
	local format = string.format
	local split = string.split

	local defaultposition = format('%s\031%s\031%s\031%d\031%d', "CENTER", "UIParent", "CENTER", 0, 0)
	
	local function GetPoint(obj)
		local point, anchor, secondaryPoint, x, y = obj:GetPoint()
		if not anchor then anchor = UIParent end

		return format('%s\031%s\031%s\031%d\031%d', point, anchor:GetName(), secondaryPoint, round(x), round(y))
	end

	
	local function SetFrameOptsCustom(name, point, anchor, secondaryPoint, x, y)
		if not C.db.profile.Frames then C.db.profile.Frames = {} end
		if not C.db.profile.Frames[name] then C.db.profile.Frames[name] = {} end
		if not C.db.profile.Frames[name].point then C.db.profile.Frames[name].point = defaultposition end	
		if not anchor then anchor = UIParent end
		
		C.db.profile.Frames[name].point = format('%s\031%s\031%s\031%d\031%d', point, anchor.GetName and anchor:GetName() or anchor, secondaryPoint, round(x), round(y))
	end
	
	
	C.SetFrameOptsCustom = SetFrameOptsCustom
	
	local function GetFrameOpts(name)
		
		if not C.db.profile.Frames then C.db.profile.Frames = {} end
		if not C.db.profile.Frames[name] then C.db.profile.Frames[name] = {} end
		if not C.db.profile.Frames[name].point then C.db.profile.Frames[name].point = defaultposition end
		
		local point, anchor, secondaryPoint, x, y = split('\031', C.db.profile.Frames[name].point)
		
		local aachor = _G[anchor] or UIParent
		
		return point, aachor, secondaryPoint, x, y
	end
	
	local function SetFrameOpts(name, obj)
		if not C.db.profile.Frames then C.db.profile.Frames = {} end
		if not C.db.profile.Frames[name] then C.db.profile.Frames[name] = {} end
		if not C.db.profile.Frames[name].point then C.db.profile.Frames[name].point = defaultposition end
		C.db.profile.Frames[name].point = GetPoint(obj)
	end

	
	local function createbutton(parent, name)
		if not parent.buttons then parent.buttons = {} end
		
		local f = CreateFrame("Button", nil , parent)
		f:SetFrameLevel(parent:GetFrameLevel() + 1)
		f.parent = parent
		f:SetText(name)
		f:SetWidth(20) --ширина
		f:SetHeight(20) --высота
		f:SetNormalFontObject("GameFontNormalSmall")
		f:SetHighlightFontObject("GameFontHighlightSmall")
		f:SetFrameStrata("HIGH")
		f:SetBackdrop({
				bgFile = [=[Interface\ChatFrame\ChatFrameBackground]=],
				edgeFile = [=[Interface\ChatFrame\ChatFrameBackground]=],
				edgeSize = 1,
				insets = {top = 0, left = 0, bottom = 0, right = 0},
					})
		f:SetBackdropColor(0,0,0,1)
		f:SetBackdropBorderColor(.3,.3,.3,1)
		
		f:SetScript("OnEnter", function(self)
				self:SetBackdropBorderColor(1,1,1,1) --цвет краев
			end)
			f:SetScript("OnLeave", function(self)
				self:SetBackdropBorderColor(.3,.3,.3,1) --цвет краев
			end)
			
		local t = f:GetFontString()
		t:SetFont("Fonts\\ARIALN.TTF", 12, "OUTLINE")
		t:SetJustifyH("CENTER")
		t:SetJustifyV("CENTER")
		f.text = t
		
		f:SetScript("OnClick", function(self)
					
			if self.owner.opt then
				local point, anchor, secondaryPoint, x, y = GetFrameOpts(self.owner.opt)		
				SetFrameOptsCustom(self.owner.opt, point, anchor, secondaryPoint, x + buttons_move[self.i][1], y + buttons_move[self.i][2])
				self.owner.frame:ClearAllPoints()
				self.owner.frame:SetPoint(GetFrameOpts(self.owner.opt))	
			end
			
			for k,v in pairs(self.owner.editboxes) do
				v:UpdateText()					
			end
		end)
				
		return f
	end

	
	local function createeditboxe(parent)
		if not parent.editboxes then parent.editboxes = {} end
		local textbox = CreateFrame("EditBox", nil, parent)
		textbox:SetFont("Fonts\\ARIALN.TTF", 12, "OUTLINE")
		textbox:SetFrameLevel(parent:GetFrameLevel() + 1)
		textbox:SetAutoFocus(false)
		textbox:SetWidth(50)
		textbox:SetHeight(20)
		textbox:SetJustifyH("LEFT")
		textbox:SetJustifyV("CENTER")
		textbox:SetFrameStrata("HIGH")
		textbox:SetBackdrop({
				bgFile = [=[Interface\ChatFrame\ChatFrameBackground]=],
				edgeFile = [=[Interface\ChatFrame\ChatFrameBackground]=],
				edgeSize = 1,
				insets = {top = 0, left = 0, bottom = 0, right = 0},
					})
		textbox:SetBackdropColor(0,0,0,1)
		textbox:SetBackdropBorderColor(1,1,1,0.5)
		
		textbox.ok = createbutton(textbox, "OK")
		textbox.ok.editbox = textbox
		textbox.ok.text:SetFont("Fonts\\ARIALN.TTF", 10, "OUTLINE")
		textbox.ok:SetSize(15,15)
		textbox.ok:SetPoint("RIGHT", textbox, "RIGHT", -2, 0)
		textbox.ok:Hide()
		
		textbox:SetScript("OnEscapePressed", function(self)
			self:ClearFocus()
		end)
		textbox:SetScript("OnEnterPressed", function(self)
			self.ChangePosition(self.ok)
		end)
		
		textbox:SetScript("OnShow", function(self) self:UpdateText() end)
		
		textbox.ChangePosition = function(self)
			local num = tonumber(self.editbox:GetText())				
			if num then
				if self.editbox.owner.opt then
					
					
					local point, anchor, secondaryPoint, x, y = GetFrameOpts(self.editbox.owner.opt)	

					if self.editbox.i == 1 then
						x = num
					else
						y = num
					end
		
					SetFrameOptsCustom(self.editbox.owner.opt, point, anchor, secondaryPoint, x, y)
					
					self.editbox.owner.frame:ClearAllPoints()
					self.editbox.owner.frame:SetPoint(GetFrameOpts(self.editbox.owner.opt))

				end
			else
				self.editbox:UpdateText()
			end
			self:SetScript("OnClick", nil)
			self:Hide()
			
			self.editbox:ClearFocus()
		end
		
		textbox.UpdateText = function(self)
			if self.owner.opt then
				local point, anchor, secondaryPoint, x, y = GetFrameOpts(self.owner.opt)	
				
				if self.i == 1 then						
					self:SetText(x)
				else
					self:SetText(y)
				end
				
			end
		end
				
				
		return textbox
	end
	
	local mover_buttons = CreateFrame("Frame", nil, UIParent)
	mover_buttons:SetPoint("CENTER")
	mover_buttons:EnableMouse(true)
	mover_buttons:SetClampedToScreen(true)
	mover_buttons:SetSize(150,50)
	mover_buttons.buttons = {}
	mover_buttons.editboxes = {}
	mover_buttons:Hide()
	mover_buttons:SetFrameStrata("HIGH")
	
	for i=1,4 do				
		mover_buttons.buttons[i] = createbutton(mover_buttons, buttons_name[i])
		mover_buttons.buttons[i].i = i
		mover_buttons.buttons[i].owner = mover_buttons
			
		if i == 1 then
			mover_buttons.buttons[i]:SetPoint("TOPRIGHT", mover_buttons, "TOP", 0, -3)
		elseif i == 2 then
			mover_buttons.buttons[i]:SetPoint("TOPRIGHT", mover_buttons, "TOP", -21, -3)
		elseif i == 3 then
			mover_buttons.buttons[i]:SetPoint("TOPLEFT", mover_buttons, "TOP", 0, -3)
		elseif i == 4 then
			mover_buttons.buttons[i]:SetPoint("TOPLEFT", mover_buttons, "TOP", 21, -3)
		end				
	end
	for i=1,2 do				
		mover_buttons.editboxes[i] = createeditboxe(mover_buttons)
		mover_buttons.editboxes[i].i = i
		mover_buttons.editboxes[i].owner = mover_buttons
		
		if i == 1 then
			mover_buttons.editboxes[i]:SetPoint("TOPRIGHT", mover_buttons, "TOP", -1, -30)
		else
			mover_buttons.editboxes[i]:SetPoint("TOPLEFT", mover_buttons, "TOP", 1, -30)
		end
		
		mover_buttons.editboxes[i]:SetScript("OnTextChanged", function(self, user)
			if user then
				self.ok:Show()
				
				self.ok:SetScript("OnClick", self.ChangePosition)
			end
		end)
		
		mover_buttons.editboxes[i]:UpdateText()
	end
	
	local function SetMoverButtons(self)

		if not mover_buttons:IsMouseOver() then
			mover_buttons.mover = self
			mover_buttons.frame = self.parent
			mover_buttons.opt = self.opt
			
			mover_buttons:ClearAllPoints()
			mover_buttons:SetParent(self)
			mover_buttons:SetPoint("TOP", self, "BOTTOM")
			mover_buttons:Show()
			
			for k,v in pairs(mover_buttons.editboxes) do
				v:UpdateText()					
			end
		end
	end

	local function MoverOnUpdate(self)
		local x, y = self.parent:GetCenter()
		local ux, uy = UIParent:GetCenter()
		local screenWidth, screenHeight = UIParent:GetRight(),UIParent:GetTop()
		
		
		local LEFT = screenWidth / 4
		local TOP = screenHeight / 4
		
		local xpos, ypos = 0, 0
		local point1, point2 =  "CENTER", ""
		local point3, point4 =  "CENTER", ""
	
		--[[
						|
						|
						|
						|
						|
						|
		  ----------------------------- OX
						|
						|
						|
						|
						|
						OY
		
		]]
	--	print("T1", LEFT, TOP)
		
		local rX, rY = round(x-ux), round(y-uy)
		
	--	print("T2", "rX", rX, "rY", rY)
	
		if rX < -LEFT then
			point1, point3 = "LEFT", "LEFT"			
		elseif rX > LEFT then
			point1, point3 = "RIGHT", "RIGHT"			
		end
		
		if rY < -TOP then
			point2, point4 = "BOTTOM", "BOTTOM"
			
			if point1 == "CENTER" then point1 = '' end
			if point3 == "CENTER" then point3 = '' end
			
		elseif rY > TOP then
			point2, point4 = "TOP", "TOP"
			
			if point1 == "CENTER" then point1 = '' end
			if point3 == "CENTER" then point3 = '' end
			
		end
		
		if point1 == "CENTER" then
			xpos, ypos = rX, rY
		else
			
			if point1 == "LEFT" then
				xpos = self.parent:GetLeft() - UIParent:GetLeft()
			elseif point1 == "RIGHT" then
				xpos = self.parent:GetRight() - UIParent:GetRight()
			else
				xpos = rX
			end
			
			if point2 == "TOP" then
				ypos = self.parent:GetTop() - UIParent:GetTop()
			elseif point2 == "BOTTOM" then
				ypos = self.parent:GetBottom() - UIParent:GetBottom()
			else
				ypos = rY
			end
		end
		
	--	print(point2..point1, engine.ParentFrame, point4..point3, xpos, ypos)
		
		SetFrameOptsCustom(self.opt,  point2..point1, UIParent, point4..point3, xpos, ypos)	
	end
	
	
	function C:Mover(frame, opt, width, height, point)
	
		frame:ClearAllPoints()
		frame:SetPoint(GetFrameOpts(opt))
		
		if movers[frame] then 
			movers[frame].opt = opt
			movers[frame].parent = frame
			movers[frame].t:SetText(opt)
			
			local _width, _height = frame:GetSize()
			
			if width or height or point then		
				movers[frame]:SetPoint(point or "TOPLEFT", frame,0,0)
				movers[frame]:SetSize(width or _width, height or _height)			
			else	
				movers[frame]:SetPoint("TOPLEFT", frame, "TOPLEFT",0,0)
				movers[frame]:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT",0,0)		
			end

			return 
		end

		local _width, _height = frame:GetSize()
		
		local mover = CreateFrame("Frame", nil, UIParent)
		mover.opt = opt
		mover.parent = frame
		mover:SetSize(10,10)
		mover:SetFrameStrata("HIGH")
		mover:SetFrameLevel(frame:GetFrameLevel()+1)
		mover.buttons = {}
	
		if width or height or point then		
			mover:SetPoint(point or "TOPLEFT", frame,0,0)
			mover:SetSize(width or _width, height or _height)			
		else	
			mover:SetPoint("TOPLEFT", frame, "TOPLEFT",0,0)
			mover:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT",0,0)		
		end
		
		mover.t = mover:CreateFontString(nil, "OVERLAY", "GameFontNormal");

		mover.t:SetPoint("CENTER", mover, "CENTER", 0, 0)	
		mover.t:SetTextColor(1,1,1)
		mover.t:SetFont(STANDARD_TEXT_FONT, 12, "OUTLINE")
		mover.t:SetAlpha(1)
		mover.t:SetJustifyH("LEFT")
		mover.t:SetText(opt)
		
		mover:SetClampedToScreen(true)
		mover:EnableMouse(true)
		mover:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground",})	
		mover:SetBackdropColor(0, 0, 0, 0.7)
		mover:SetMovable(false)
		mover:RegisterForDrag("LeftButton")
		mover:Hide()
		mover:SetScript("OnDragStart", function(self) 
			self.parent:StartMoving(); 		
			self:SetScript("OnUpdate", MoverOnUpdate)
		end)
		mover:SetScript("OnDragStop", function(self) 
			self.parent:StopMovingOrSizing()
			self:SetScript("OnUpdate", nil)

			for k,v in pairs(mover_buttons.editboxes) do
				v:UpdateText()					
			end
		end)
		
		mover:SetScript("OnEnter", SetMoverButtons)
		
		movers[frame] = mover
		
		return movers[frame]
	end
	
	
	SlashCmdList["FERALDOTDAMAGEMOVEFRAMES"] = function()
		
		for k,v in pairs(movers) do
			
			if v and v:IsShown() then
				v:Hide()
				v.parent:SetMovable(false)
			else
				v:Show()
				v.parent:SetMovable(true)
			end
		end
	end
	
	function C:UnlockAllMovers()	
		for k,v in pairs(movers) do
			
			if v and v:IsShown() then
				v:Hide()
				v.parent:SetMovable(false)
			else
				v:Show()
				v.parent:SetMovable(true)
			end
		end
	end
	
	function C:UnlockMover(opt)
		
		for k,v in pairs(movers) do		
			if v.opt == opt then
				if v and v:IsShown() then
					v:Hide()
					v.parent:SetMovable(false)
				else
					v:Show()
					v.parent:SetMovable(true)
				end
				break
			end
		end
	end
	
	SLASH_FERALDOTDAMAGEMOVEFRAMES1 = "/fddmovers"

end

--------автоинвайт-------------------------------

do
	local keyword = { ["инв"] = true, ["inv"] = true, }
	local InviteUnit = InviteUnit
	local GetNumGuildMembers = GetNumGuildMembers
	local GetGuildRosterInfo = GetGuildRosterInfo
	local BNInviteFriend = BNInviteFriend
	local BNSendWhisper = BNSendWhisper
	local GetNumGroupMembers = GetNumGroupMembers
	local UnitFactionGroup = UnitFactionGroup
	local strsplit = strsplit
	
	local Custom_BNGetToonInfo = BNGetToonInfo or BNGetGameAccountInfo
	
	
	local function ConvertToRaidOrNot()		
		if not UnitIsGroupLeader("player") and not UnitIsGroupAssistant("player") then return end
		
		
		if GetNumGroupMembers() > 4 then
			ConvertToRaid()
		else
			ConvertToParty()
		end
		
	--	print("T4", "ConvertToRaidOrNot", IsInRaid(), IsInGroup(), GetNumGroupMembers())
	end

	local trottleInviteUnit = {}
	
	local function StripServer(nameserver)	
		local name, server = strsplit("-", nameserver)		
		local player, plserver = UnitFullName("player")		
		
	--	print("T", server, plserver, nameserver)
		
		if plserver == server then
			return name
		end
		return nameserver
	end
	
	local function InviteTrottle(self, elapsed)
		self.elapsed = self.elapsed + elapsed
		
		if self.elapsed < 0.3 then return end
			self.elapsed = 0

		local i2 = 0
		
		for name, invtype in pairs(trottleInviteUnit) do
			if invtype == "normal" then			
				InviteUnit(name)
				trottleInviteUnit[name] = false
				
			--	print("Invite unit by normal")
				
				ConvertToRaidOrNot()	

				i2 = i2 + 1
				
				break; 
			elseif invtype == "btnet" then
				BNInviteFriend(name)
				trottleInviteUnit[name] = false
				
			--	print("Invite unit by brnet")		
				
				ConvertToRaidOrNot()
				
				i2 = i2 + 1
				
				break;
			end
		end
		
		if i2 == 0 then 
			self:Hide() 
			
		--	print("Stop trottle")
		end
	end
	
	local trottle =  CreateFrame("Frame")
	trottle.elapsed = 0
	trottle:SetScript("OnUpdate", InviteTrottle)
	
	local function AddToInvite(name, invtype)	
		if invtype == "normal" then	
			trottleInviteUnit[StripServer(name)] = invtype
		else
			trottleInviteUnit[name] = invtype
		end
		
	--	print("T2", trottle:IsShown(), name, invtype)
		
		if not trottle:IsShown() then
			trottle.elapsed = 0
			trottle:Show()
		end
	end
	
	local function NotInRaid(name)
		
		if UnitInRaid(StripServer(name)) then return false end
		if UnitInParty(StripServer(name)) then return false end
	
		return true
	end
	
	
	function C:InviteWhisper(event, msg, author, ...)
	
		if not C.db.profile.others.AutoInv then return end

		if keyword[msg] and NotInRaid(author) then
			if C.db.profile.others.AutoInvGuildOnly then
				for i = 1, GetNumGuildMembers() do
					local name = GetGuildRosterInfo(i)
					if name == author then						
				
						if GetNumGroupMembers() == 40 then
							SendChatMessage("Я не могу Вас пригласить так как рейд полон", "WHISPER", nil, author)
						else						
							AddToInvite(author, "normal")
						end
						break
					end
				end
			else
				if GetNumGroupMembers() == 40 then					
					SendChatMessage("Я не могу Вас пригласить так как рейд полон", "WHISPER", nil, author)
				else
					AddToInvite(author, "normal")
				end
			end
		end
	end

	function C:BNInviteWhisper(event, msg, author, ...)
		local arg9 = select(9, ...)	
		local arg10 = select(11, ...)
	
		if not C.db then return end
		if not C.db.profile.others.AutoInv then return end
		--BNInviteFriend(286)
		
		local _, toonName, client, realmName, realmID, faction, _, _, _, _, level,_,_,_, _, _ = Custom_BNGetToonInfo(arg10)

		if keyword[msg] and NotInRaid(toonName) and client == BNET_CLIENT_WOW then
			if C.db.profile.others.AutoInvGuildOnly then
				
				local toonName2 = format("%s-%s", toonName, gsub(realmName," ", ''))
				
				for i = 1, GetNumGuildMembers() do
					local name = GetGuildRosterInfo(i)
					
					if name == toonName2 then
						if GetNumGroupMembers() == 40 then
							BNSendWhisper(arg10, "Я не могу Вас пригласить так как рейд полон")
						else
							AddToInvite(arg10, "btnet")
						end
						break
					end
				end
			else
				if client == BNET_CLIENT_WOW then
					if faction == UnitFactionGroup("player") then
						if GetNumGroupMembers() == 40 then
							BNSendWhisper(arg10, "Я не могу Вас пригласить так как рейд полон")
						else
							AddToInvite(arg10, "btnet")
						end
					else
						BNSendWhisper(arg10, "Я не могу Вас пригласить так как вы принадлежите к другой фракции")
					end
				else
					-- "Нет клиента вов"
					--	BNSendWhisper(arg10, "Вы должны иметь")
				end
			end
		end
	end
	
	local events = CreateFrame("Frame")	
	events:RegisterEvent("CHAT_MSG_WHISPER")
	events:RegisterEvent("CHAT_MSG_BN_WHISPER")
	events:SetScript("OnEvent", function(self, event, ...)	
		if event == "CHAT_MSG_BN_WHISPER" then
			C:BNInviteWhisper(event, ...)
		elseif event == "CHAT_MSG_WHISPER" then
			C:InviteWhisper(event, ...)
		end
	end)
end

do
	-- Copy from LibButtonGlow-1.0
	
	local unusedOverlays = {}
	local numOverlays = 0

	local tinsert, tremove, tostring = table.insert, table.remove, tostring

	local function OverlayGlowAnimOutFinished(animGroup)
		local overlay = animGroup:GetParent()
		local frame = overlay:GetParent()
		overlay:Hide()
		tinsert(unusedOverlays, overlay)
		frame.__FDDoverlay = nil
	end

	local function OverlayGlow_OnHide(self)
		if self.animOut:IsPlaying() then
			self.animOut:Stop()
			OverlayGlowAnimOutFinished(self.animOut)
		end
	end

	local function CreateScaleAnim(group, target, order, duration, x, y, delay)
		local scale = group:CreateAnimation("Scale")
		scale:SetTarget(target:GetName())
		scale:SetOrder(order)
		scale:SetDuration(duration)
		scale:SetScale(x, y)

		if delay then
			scale:SetStartDelay(delay)
		end
	end

	local function CreateAlphaAnim(group, target, order, duration, fromAlpha, toAlpha, delay)
		local alpha = group:CreateAnimation("Alpha")
		alpha:SetTarget(target:GetName())
		alpha:SetOrder(order)
		alpha:SetDuration(duration)
		alpha:SetFromAlpha(fromAlpha)
		alpha:SetToAlpha(toAlpha)

		if delay then
			alpha:SetStartDelay(delay)
		end
	end

	local function AnimIn_OnPlay(group)
		local frame = group:GetParent()
		local frameWidth, frameHeight = frame:GetSize()
		frame.spark:SetSize(frameWidth, frameHeight)
		frame.spark:SetAlpha(0.3)
		frame.innerGlow:SetSize(frameWidth / 2, frameHeight / 2)
		frame.innerGlow:SetAlpha(1.0)
		frame.innerGlowOver:SetAlpha(1.0)
		frame.outerGlow:SetSize(frameWidth * 2, frameHeight * 2)
		frame.outerGlow:SetAlpha(1.0)
		frame.outerGlowOver:SetAlpha(1.0)
		frame.ants:SetSize(frameWidth * 0.85, frameHeight * 0.85)
		frame.ants:SetAlpha(0)
		frame:Show()
	end

	local function AnimIn_OnFinished(group)
		local frame = group:GetParent()
		local frameWidth, frameHeight = frame:GetSize()
		frame.spark:SetAlpha(0)
		frame.innerGlow:SetAlpha(0)
		frame.innerGlow:SetSize(frameWidth, frameHeight)
		frame.innerGlowOver:SetAlpha(0.0)
		frame.outerGlow:SetSize(frameWidth, frameHeight)
		frame.outerGlowOver:SetAlpha(0.0)
		frame.outerGlowOver:SetSize(frameWidth, frameHeight)
		frame.ants:SetAlpha(1.0)
	end

	local function CreateOverlayGlow()
		numOverlays = numOverlays + 1

		-- create frame and textures
		local name = "FDDGlowOverlay" .. tostring(numOverlays)
		local overlay = CreateFrame("Frame", name, UIParent)

		-- spark
		overlay.spark = overlay:CreateTexture(name .. "Spark", "BACKGROUND")
		overlay.spark:SetPoint("CENTER")
		overlay.spark:SetAlpha(0)
		overlay.spark:SetTexture([[Interface\SpellActivationOverlay\IconAlert]])
		overlay.spark:SetTexCoord(0.00781250, 0.61718750, 0.00390625, 0.26953125)

		-- inner glow
		overlay.innerGlow = overlay:CreateTexture(name .. "InnerGlow", "ARTWORK")
		overlay.innerGlow:SetPoint("CENTER")
		overlay.innerGlow:SetAlpha(0)
		overlay.innerGlow:SetTexture([[Interface\SpellActivationOverlay\IconAlert]])
		overlay.innerGlow:SetTexCoord(0.00781250, 0.50781250, 0.27734375, 0.52734375)

		-- inner glow over
		overlay.innerGlowOver = overlay:CreateTexture(name .. "InnerGlowOver", "ARTWORK")
		overlay.innerGlowOver:SetPoint("TOPLEFT", overlay.innerGlow, "TOPLEFT")
		overlay.innerGlowOver:SetPoint("BOTTOMRIGHT", overlay.innerGlow, "BOTTOMRIGHT")
		overlay.innerGlowOver:SetAlpha(0)
		overlay.innerGlowOver:SetTexture([[Interface\SpellActivationOverlay\IconAlert]])
		overlay.innerGlowOver:SetTexCoord(0.00781250, 0.50781250, 0.53515625, 0.78515625)

		-- outer glow
		overlay.outerGlow = overlay:CreateTexture(name .. "OuterGlow", "ARTWORK")
		overlay.outerGlow:SetPoint("CENTER")
		overlay.outerGlow:SetAlpha(0)
		overlay.outerGlow:SetTexture([[Interface\SpellActivationOverlay\IconAlert]])
		overlay.outerGlow:SetTexCoord(0.00781250, 0.50781250, 0.27734375, 0.52734375)

		-- outer glow over
		overlay.outerGlowOver = overlay:CreateTexture(name .. "OuterGlowOver", "ARTWORK")
		overlay.outerGlowOver:SetPoint("TOPLEFT", overlay.outerGlow, "TOPLEFT")
		overlay.outerGlowOver:SetPoint("BOTTOMRIGHT", overlay.outerGlow, "BOTTOMRIGHT")
		overlay.outerGlowOver:SetAlpha(0)
		overlay.outerGlowOver:SetTexture([[Interface\SpellActivationOverlay\IconAlert]])
		overlay.outerGlowOver:SetTexCoord(0.00781250, 0.50781250, 0.53515625, 0.78515625)

		-- ants
		overlay.ants = overlay:CreateTexture(name .. "Ants", "OVERLAY")
		overlay.ants:SetPoint("CENTER")
		overlay.ants:SetAlpha(0)
		overlay.ants:SetTexture([[Interface\SpellActivationOverlay\IconAlertAnts]])

		-- setup antimations
		overlay.animIn = overlay:CreateAnimationGroup()
		CreateScaleAnim(overlay.animIn, overlay.spark,          1, 0.2, 1.5, 1.5)
		CreateAlphaAnim(overlay.animIn, overlay.spark,          1, 0.2, 0, 1)
		CreateScaleAnim(overlay.animIn, overlay.innerGlow,      1, 0.3, 2, 2)
		CreateScaleAnim(overlay.animIn, overlay.innerGlowOver,  1, 0.3, 2, 2)
		CreateAlphaAnim(overlay.animIn, overlay.innerGlowOver,  1, 0.3, 1, 0)
		CreateScaleAnim(overlay.animIn, overlay.outerGlow,      1, 0.3, 0.5, 0.5)
		CreateScaleAnim(overlay.animIn, overlay.outerGlowOver,  1, 0.3, 0.5, 0.5)
		CreateAlphaAnim(overlay.animIn, overlay.outerGlowOver,  1, 0.3, 1, 0)
		CreateScaleAnim(overlay.animIn, overlay.spark,          1, 0.2, 2/3, 2/3, 0.2)
		CreateAlphaAnim(overlay.animIn, overlay.spark,          1, 0.2, 1, 0, 0.2)
		CreateAlphaAnim(overlay.animIn, overlay.innerGlow,      1, 0.2, 1, 0, 0.3)
		CreateAlphaAnim(overlay.animIn, overlay.ants,           1, 0.2, 0, 1, 0.3)
		overlay.animIn:SetScript("OnPlay", AnimIn_OnPlay)
		overlay.animIn:SetScript("OnFinished", AnimIn_OnFinished)

		overlay.animOut = overlay:CreateAnimationGroup()
		CreateAlphaAnim(overlay.animOut, overlay.outerGlowOver, 1, 0.2, 0, 1)
		CreateAlphaAnim(overlay.animOut, overlay.ants,          1, 0.2, 1, 0)
		CreateAlphaAnim(overlay.animOut, overlay.outerGlowOver, 2, 0.2, 1, 0)
		CreateAlphaAnim(overlay.animOut, overlay.outerGlow,     2, 0.2, 1, 0)
		overlay.animOut:SetScript("OnFinished", OverlayGlowAnimOutFinished)

		-- scripts
		overlay:SetScript("OnUpdate", ActionButton_OverlayGlowOnUpdate)
		overlay:SetScript("OnHide", OverlayGlow_OnHide)
		
		return overlay
	end

	local function GetOverlayGlow()
		local overlay = tremove(unusedOverlays)
		if not overlay then
			overlay = CreateOverlayGlow()
		end
		return overlay
	end
	
	local glow_spacing = 0.4
	
	function FeralDotDamage.ShowOverlayGlow(frame)
		if frame.__FDDoverlay then
			if frame.__FDDoverlay.animOut:IsPlaying() then
				frame.__FDDoverlay.animOut:Stop()
				frame.__FDDoverlay.animIn:Play()
			end
		else
			local overlay = GetOverlayGlow()
			local frameWidth, frameHeight = frame:GetSize()
			overlay:SetParent(frame)
			overlay:SetFrameLevel(frame:GetFrameLevel() + 5)
			overlay:ClearAllPoints()
		
			overlay:SetSize(frameWidth * 1.4, frameHeight * 1.4)
			overlay:SetPoint("TOPLEFT", frame, "TOPLEFT", -frameWidth * glow_spacing, frameHeight * glow_spacing)
			overlay:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", frameWidth * glow_spacing, -frameHeight * glow_spacing)
	
	
			overlay.animIn:Play()
			frame.__FDDoverlay = overlay

			if Masque and Masque.UpdateSpellAlert and (not frame.overlay or not issecurevariable(frame, "overlay")) then
				local old_overlay = frame.overlay
				frame.overlay = overlay
				Masque:UpdateSpellAlert(frame)

				frame.overlay = old_overlay
			end
		end
	end

	function FeralDotDamage.HideOverlayGlow(frame)
		if frame.__FDDoverlay then
			if frame.__FDDoverlay.animIn:IsPlaying() then
				frame.__FDDoverlay.animIn:Stop()
			end
			if frame:IsVisible() then
				frame.__FDDoverlay.animOut:Play()
			else
				OverlayGlowAnimOutFinished(frame.__FDDoverlay.animOut)
			end
		end
	end
end